<?php
defined('BASEPATH') OR exit('No direct script access allowed');

/*
| -------------------------------------------------------------------------
| URI ROUTING
| -------------------------------------------------------------------------
| This file lets you re-map URI requests to specific controller functions.
|
| Typically there is a one-to-one relationship between a URL string
| and its corresponding controller class/method. The segments in a
| URL normally follow this pattern:
|
|	example.com/class/method/id/
|
| In some instances, however, you may want to remap this relationship
| so that a different class/function is called than the one
| corresponding to the URL.
|
| Please see the user guide for complete details:
|
|	https://codeigniter.com/user_guide/general/routing.html
|
| -------------------------------------------------------------------------
| RESERVED ROUTES
| -------------------------------------------------------------------------
|
| There are three reserved routes:
|
|	$route['default_controller'] = 'welcome';
|
| This route indicates which controller class should be loaded if the
| URI contains no data. In the above example, the "welcome" class
| would be loaded.
|
|	$route['404_override'] = 'errors/page_missing';
|
| This route will tell the Router which controller/method to use if those
| provided in the URL cannot be matched to a valid route.
|
|	$route['translate_uri_dashes'] = FALSE;
|
| This is not exactly a route, but allows you to automatically route
| controller and method names that contain dashes. '-' isn't a valid
| class or method name character, so it requires translation.
| When you set this option to TRUE, it will replace ALL dashes in the
| controller and method URI segments.
|
| Examples:	my-controller/index	-> my_controller/index
|		my-controller/my-method	-> my_controller/my_method
*/
$route['default_controller'] = 'Sites';
$route['404_override'] = '';
$route['translate_uri_dashes'] = FALSE;
$route['outComes'] = "Sites/outComes";
$route['login'] = "Auth/login";
$route['logout'] = "Auth/logout";
$route['Sites'] = "Sites/index";
$route['Users'] = "Users/index";
$route['tutorials'] = "Sites/tutorials";
$route['publish'] = "Sites/publish";

//Choode template
$route['(:num)/Template'] = "sites/Template/$1";

// $route['Analytics/(:num)'] = "Sites/Analytics/$1";
// $route['Analytics'] = "Sites/Analytics";


$route['Appearance/(:num)'] = "Sites/Appearance/$1";
$route['Appearance'] = "Sites/Appearance";

// $route['microbuzz/(:num)'] = "Sites/microbuzz/$1";
// $route['microbuzz/(:num)/(:num)'] = "Sites/microbuzz/$1/$2";

// $route['exportSubscribe/(:num)'] = 'Sites/exportCsvSubscribe/$1';
// $route['exportSpinwheel/(:num)'] = 'Sites/exportCsvSpinwheel/$1';

// $route['youzign'] = "Sites/youzignsetting";

// subdomains section

$route['subdomains'] = "subdomain/index";
$route['checkSubdomain'] = "subdomain/checkSub";
$route['configureSubdomain/(:any)'] = "subdomain/configureSubdomain/$1";
$route['createsub'] = "subdomain/createsub";
$route['Csubdomain'] = "subdomain/create";
$route['(:num)/stories'] = "sites/storyDashboard/$1";
$route['(:num)/stories/(:num)'] = "sites/storyDashboard/$1/$2";
$route['(:num)/Create'] = "sites/Create/$1";
$route['addToaction'] = "subdomain/addToaction";

//request from admin
$route['deleteSubdomain'] = "subdomain/remove_subdomain";
$route['restoreDomain'] = "subdomain/restore_subdomain";

//request from client
$route['deleteSubdomainRequest'] = "subdomain/requestDeleteSubdomain";

//list all requests
$route['subdomaindelrequest'] = "subdomain/listRemovedSubdomain";

//pagination routes
$route['subdomaindelrequest/(:any)'] = "subdomain/listRemovedSubdomain/$1/";
$route['subdomaindelrequest/(:any)/(:any)'] = "subdomain/listRemovedSubdomain/$1/$2";
$route['check_user_exits/(:any)/(:any)'] = 'Wpconnector/check_login_valid/$1/$2';

// $route['get_pages'] = "wpconnector/get_pages";

// $route['dfy'] = "Sites/dfycampaigns";

// $route[':any/([0-9]+)'] = 'Embed/innerpage/';
// //$route['([0-9])'] = 'Embed/homepage/';
// $route['([0-9])+'] = 'Embed/S/';
// $route[':any'] = 'Embed/homepage/';

$route['Editor/(:any)'] = 'Sites/editSite/$1';
$route['article/(:any)'] = 'Sites/articlelist/$1';
$route['uploadImage'] = "Products/uploadProductImage";

$route['website/(:any)'] = 'Embed/website/$1';
$route['website/(:any)/(:any)'] = 'Embed/website/$1/$2';

// -------------------------------------------------------------------

$route['createarticle/(:any)'] = 'Sites/createarticle/$1';
$route['createarticlepost'] = 'Sites/createarticlepost';

$route['deletearticle'] = 'Sites/deletearticle';
$route['deletearticlefromview/(:any)'] = 'Sites/deletearticlefromview/$1';

$route['editarticle/(:any)/(:any)'] = 'Sites/editarticle/$1/$2';
$route['updatearticle'] = 'Sites/updatearticle';

$route['viewarticle/(:any)/(:any)'] = 'Sites/viewarticle/$1/$2';

// ------------------------------------------------------------------

$route['editprofile'] = "Sites/editprofile";
$route['updateprofile'] = "Sites/updateprofile";

// ------------------------------------------------------------------

$route['statistics'] = "sites/statistics";
$route['statistics/(:any)'] = "sites/statistics/$1";

$route['access'] = "sites/myaccess";

// ------------------------------------------------------------------

$route['auto_responder'] = "settings/auto_responder";
$route['addresponder/(:any)']="settings/addresponder/$1";
$route['saveresponder']="settings/saveresponder";
$route['getAweberCred']="settings/getAweberCred";
$route['getGtwCred']="settings/getGtwCred";