<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Products extends CI_Controller {
	
    public function __construct(){
        parent::__construct();
        $this->load->library('product_lib');
    }
	
    /*
        List the Users Products according to subdomain with pagination
    */

	public function index($param,$page='',$search=null)
    {
        $subdomain_id = $this->app_lib->validateURL($param,$this->user_id);

        // echo $subdomain_id;
        if($subdomain_id!=0)
        {
            $this->data['subdomain_data'] = $this->app_lib->fetchTableData('subdomains',array('id' => $subdomain_id));
            

            if ($page == ''){
                $page = 0;
            }else{
                $page = $page - 1; 
            }
            $itemsPerPage = 20;

            $user_id = $this->user_id;

            

            $where['subdomain_id'] = $subdomain_id;

            // print_r($where);exit;
            $this->data['products'] = $this->app_lib->fetchAll($itemsPerPage,$page,'products',$where,'created_date');
            $total_row = $this->app_lib->checkExit('products',$where);
            $this->data['total_row'] = $total_row;
            $this->data['active_row'] = $this->app_lib->checkExit('products',array('subdomain_id' => $subdomain_id,'status'=>1));


            // print_r($this->data['products']);
            // exit;
            

            $config['base_url'] =base_url("products/".$param);
            $config['total_rows'] = $total_row;
            $config["per_page"] = $itemsPerPage;  
            $config['use_page_numbers'] = TRUE;

            $config['next_link'] = 'Next';
            $config['first_link'] = 'First';
            $config['last_link'] = 'Last';
            $config['prev_link'] = 'Previous';

            $config['first_tag_open'] = '<li>';
            $config['first_tag_close'] = '</li>';
            $config['first_url'] = '';
            // $config['last_link'] = 'Last';
            $config['last_tag_open'] = '<li>';
            $config['last_tag_close'] = '</li>';


            $config['next_tag_open'] = '<li>';
            $config['next_tag_close'] = '</li>';

            $config['prev_tag_open'] = '<li>';
            $config['prev_tag_close'] = '</li>';

            $config['num_tag_open'] = '<li>';
            $config['num_tag_close'] = '</li>';
            $config['cur_tag_open'] = '<li class="active"><a class="current">';
            $config['cur_tag_close'] = '</a></li>';
          
            $this->pagination->initialize($config); 
            if($this->uri->segment(3)){
                $page = ($this->uri->segment(3)) ;
            }
            else{
                $page = 1;
            } 
            
            $str_links = $this->pagination->create_links();
            $this->data["links"] = explode('&nbsp;',$str_links );       
            $this->data['pageTitle'] = 'Products';
            $this->data['controller'] = $this;

            $this->app_lib->_render_page('product',$this->data);    
            


        }else{
            echo 'URL Not found';
        }


    }


    /*
        Create a munal products load view page
    */
    public function createProduct($param)
    {
        $subdomain_id = $this->app_lib->validateURL($param,$this->user_id);

        // echo $subdomain_id;
        if($subdomain_id!=0)
        {
            $this->data['subdomain_data'] = $this->Datamodel->fetchTableData('subdomains',array('id' => $subdomain_id));
            $this->app_lib->_render_page("createProduct",$this->data);
            
        }else{
            echo 'URL Not found';
        }
    }


    /*
        Edit Product
    */
    public function editProduct($subdomain_id,$product_id)
    {
        // echo $subdomain_id;
        $where = array('subdomain_id'=>$subdomain_id,'id'=>$product_id);

        $check = $this->app_lib->checkExit('products',$where);
        if($check==1)
        {
            $this->data['subdomain_data'] = $this->Datamodel->fetchTableData('subdomains',array('id' => $subdomain_id));
            $this->data['product_data'] = $this->Datamodel->fetchTableData('products',array('id' => $product_id));

            // print_r($this->data['product_data']);exit;
            $this->data['pageTitle'] = "Edit Product";
            $this->app_lib->_render_page("singleProduct",$this->data);
        }
        else
        {
            echo "Invali URL";
        }

    }




    /**
     *  Fetch API products 
     *  eg : Amazon , ebay and clickbank
    */
       
    public function apiProductSearch()
    {
        $htmlData = '';
        $search_source = $_REQUEST['search_source'];
        $subdomain_id = $_POST['subdomain_id'];
        $keyword = $_POST['keyword'];
        $result = array();

        if($search_source=='amazon')
        {
            $amazonData = $this->app_lib->fetchTableData('settings',array("user_id"=>$this->user_id,'meta_type'=>'amazon'));

            $result = array('status' => 200,'response'=>'');

            if(empty($amazonData))
            {
                $result['status'] = '404';
                $result['error'] = 'API Key not Valid or present';
            }
            else
            {
                $api_keys = unserialize($amazonData[0]['Data']->meta_data);

                // print_r($api_keys);
                $access_key = $api_keys['access_key'];
                $secret_key = $api_keys['secret_key'];
                $amazon_country = $api_keys['amazon_country'];
                $amazon_tag_id = $api_keys['tag_id'];
                
                $category = $_POST['amz_category'];

                $page_id = (string)trim($_POST['page_no']);

                if($page_id == 1)
                {
                    $page_id = 1;
                }elseif ($page_id == 2) {
                    $page_id = 2;
                    
                }
                elseif ($page_id == 3) {
                    $page_id = 3;
                    
                }
                elseif ($page_id == 4) {
                    $page_id = 4;
                    
                }else
                {
                    $page_id = 5;
                }

                $data = $this->product_lib->fetchAmazon($api_keys,$keyword,$category,$page_id);

                if(!empty($data))
                {
                    foreach ($data as $key => $item) {
                        $ASIN = $item->getASIN();
                        $product_title = $item->getItemInfo()->getTitle()->getDisplayValue();
                        $product_images = $item->getImages()->getprimary()->getLarge()->getuRL();
                        $product_url = $item->getDetailPageURL();
                        
                        
                        if ($item->getOffers() != null
                            and $item->getOffers() != null
                            and $item->getOffers()->getListings() != null
                            and $item->getOffers()->getListings()[0]->getPrice() != null
                            and $item->getOffers()->getListings()[0]->getPrice()->getDisplayAmount() != null) {
                            $product_price = $item->getOffers()->getListings()[0]->getPrice()
                                ->getDisplayAmount();
                        }


                            if($item->getItemInfo()->getFeatures())
                            {
                                $product_description = $item->getItemInfo()->getFeatures()->getDisplayValues();

                            }
                            else
                            {
                                $product_description = '';
                            }
                        // print_r($product_description);
                        // exit;
                        if(!empty($product_description))
                        {
                            $product_description = base64_encode(implode(",", $product_description));
                        }

                        if(!empty($buy_now_amazon_track))
                        {
                            $product_url = str_ireplace($amazon_tag_id, $buy_now_amazon_track, $product_url);

                        }

                        $check = $this->app_lib->checkExit('products',['subdomain_id' => $subdomain_id ,'asin_id' => $ASIN]);

                        if($check == 0)
                        {
                            $importBtn = '<a href="javascript:void(0)" class="addProduct btn btn-primary" data-product_id = "'.$ASIN.'" data-source="amazon" data-description = "'.$product_description.'" data-title="'.base64_encode($product_title).'" data-price="'.$product_price.'" data-currency="" data-thumbnail ="'.$product_images.'" data-buynow="'.$product_url.'">Import</a>';
                        }
                        else
                        {
                            $importBtn = '<a href="javascript:void(0)" class="btn btn-success">Already Imported</a>';
                        }
                        
                        $htmlData .= '<div class="col-md-6 col-lg-6 col-xl-3">
        
                            <div class="card">
                                <div class="card-body">
                                    <h4 class="card-title  mt-0"><i class="to-ebay"></i></h4>
                                    <h6 class="card-subtitle font-14 text-muted">
                                    <input type="checkbox" data-product_id = "'.$ASIN.'" data-source="amazon" data-description = "'.$product_description.'" data-title="'.base64_encode($product_title).'" data-price="'.$product_price.'" data-currency="" data-thumbnail ="'.$product_images.'" data-buynow="'.$product_url.'" class="importProduct">
                                    <span class="float-right">Price : <span class="text-danger">'.$product_price.'</span></span></h6>
                                </div>
                                <img class="img-fluid" src="'.$product_images.'" alt="Card image cap">
                                <div class="card-body">
                                    <p class="card-text">'.$product_title.'</p>
                                    <p><span class="text-success">ASIN</span> '.$ASIN.'  <a href="'.$product_url.'" data-toggle="tooltip" title="View Product" class="float-right text-muted" target="_blank"><i class="ti-eye"></i></a> </p>
                                    
                                    
                                           <p class="text-center">'.$importBtn.'</p>
                                    
                                </div>
                            </div>

                         </div>';
                        
                    }

                    

                    // $htmlData .= "</div>";
                    $result['status'] = '200';
                    $result['response'] = $htmlData;
                }


            }
        }
        elseif ($search_source == 'ebay') {
            $ebayData = $this->app_lib->fetchTableData('settings',array("user_id"=>$this->user_id,'meta_type'=>'ebay'));
            $api_keys = unserialize($ebayData[0]['Data']->meta_data);

            $categoryId = $_POST['ebay_category'];
                // echo $categoryId;
            
            $page_no = $_POST['page_no'];
            
            $available_to='';
            $price_from='';
            $price_to='';
            $feedback_min='';
            $feedback_max='';
            $shipment_min_price='';
            $shipment_price_max='';
            $site='';
            $condition='';

            $ebayarray = $this->product_lib->fetchEbay($keyword , $categoryId ,$page_no ,$price_from  ,$price_to ,$feedback_min , $feedback_max ,$available_to ,$shipment_min_price,$shipment_price_max,$site,$condition,$api_keys);

           if($ebayarray['ack'] == 'Success')
            {
                // echo "string";

                foreach($ebayarray['searchResult']['item'] as $item) 
                {

                    // print_r($item);exit;
                    $thumbnail   = $item['galleryURL'];
                    $link  = $item['viewItemURL'];
                    $title = $item['title'];
                    $price = $item['sellingStatus']['currentPrice'];
                    $id=$item['itemId'];
                    $currency = $item['country'];
                    
                    // $title = strlen($title) > 60? substr($title,0,60)."..." : $title;

                    $mpre           = rawurlencode($link);

                    $campid         = $api_keys['ebayappid'];
                    $globalId       = $api_keys['country'];
                    $globalid = str_replace('EBAY-', '',$globalId );    
                    //$campid       = 123465;
                    //var_dump($globalid);die;
                    $lgeo           = 0;
                    $ff3            = 2; // it's an item link 
                    //$vectorid         = $this->get_vectorid( $globalid );
                    $rotationid     = $this->product_lib->get_rotationid( $globalid );
                    $toolid         = 10044;
                    $actualUrl =  'http://rover.ebay.com/rover/1/' . ( $rotationid ) . '/1?ff3=' . ( $ff3) . '&toolid=' . ( $toolid) . '&campid=' . ( $campid) . '&customid=APIcallSKF&lgeo=' . ( $lgeo) . '&mpre=' . $mpre;        


                    $check = $this->app_lib->checkExit('products',['subdomain_id' => $subdomain_id ,'asin_id' => $id]);
                    
                    if($check == 0)
                    {
                        $importBtn = '<a href="javascript:void(0)" data-description = "" class="addProduct btn btn-primary" data-product_id = "'.$id.'" data-source="ebay" data-title="'.base64_encode($title).'" data-price="'.$price.'" data-currency="'.$currency.'" data-thumbnail ="'.$thumbnail.'" data-buynow="'.$actualUrl.'">Import
                                </a>';
                    }
                    else
                    {
                        $importBtn = '<a href="javascript:void(0)" class="btn btn-success">Already Imported</a>';
                    }

                    $htmlData .= '<div class="col-md-6 col-lg-6 col-xl-3">
        
                    <div class="card">
                        <div class="card-body">
                            <h4 class="card-title  mt-0"><i class="to-ebay"></i></h4>
                            <h6 class="card-subtitle font-14 text-muted">
                            <input type="checkbox"  data-product_id = "'.$id.'" data-source="ebay" data-title="'.base64_encode($title).'" data-price="'.$price.'" data-currency="'.$currency.'" data-thumbnail ="'.$thumbnail.'" data-buynow="'.$actualUrl.'" data-description = ""  class="importProduct">
                            <span class="float-right">Price : <span class="text-danger">'.$price.'</span></span></h6>
                        </div>
                        <img class="img-fluid" src="'.$thumbnail.'" alt="Card image cap">
                        <div class="card-body">
                            <p class="card-text">'.$title.'</p>
                            <p><span class="text-success">ASIN</span> '.$id.' <a href="'.$actualUrl.'" data-toggle="tooltip" title="View Product" class="float-right text-muted" target="_blank"><i class="ti-eye"></i></a> </p>
                            
                            
                                   <p class="text-center">'.$importBtn.'</p>
                            
                        </div>
                    </div>

                 </div>';


                }
                // $htmlData .= "</div>";
                $result['status'] = '200';
                $result['response'] = $htmlData;
            }
        }
        else
        {
            $clickbankData = $this->app_lib->fetchTableData('settings',array("user_id"=>$this->user_id,'meta_type'=>'clickbank'));

            $api_keys = unserialize($clickbankData[0]['Data']->meta_data);
            $clickbank = $api_keys['username'];

            $rules = [];

            $url = $this->product_lib->generateClickbankUrl($clickbank,$keyword,$rules,20);

            $api_key = $clickbank;
            $data = $this->product_lib->scrapeClickbank($url,$clickbank);

            preg_match_all('/details">.*?(https?:\/\/zzzzz\..*?net).*?>(.*?)<\/a>/s', $data, $matches, PREG_PATTERN_ORDER );
            preg_match_all('/stats">.*?(https?:\/\/zzzzz\..*?net).*?>(.*?)<\/a>/s', $data, $stats, PREG_PATTERN_ORDER );

            // print_r($stats[0]);exit;

            $links = $matches[1];
            $titles = $matches[2];
            $stats = $stats[0];
            $cont             = 0;

            preg_match_all("/\<div class=\"description\"\>(.*?)\<\/div\>/is",
            $data, $matches_desc );
            // preg_match_all('{description">(.*?)</div>}', $cont, $matches, PREG_PATTERN_ORDER );

            // print_r($matches);exit;
            $descs = $matches_desc[1];

            $items = array();
            for($i = 0; $i < count($links); $i++) 
            {
                $env = array();
                 $stats_arr = array();
                $title = addslashes($titles[$i]); 
                $link_url = str_replace('zzzzz', $api_key, $links[$i]);
                if(isset($descs[$i]))
                {
                    $desc = addslashes($descs[$i]);
                }
                else
                {
                    $desc = $title;
                }
                $s = $stats[$i];
                // print_r($s);exit;
                preg_match_all('~<span class="statWrap"[^>]*>(.*?)</span>~si', $s, $statistics);
                // $statistics = $s;
                // print_r($statistics);exit;
                if(is_array($statistics) && !empty($statistics) && array_key_exists(1, $statistics))
                {
                   
                    foreach ($statistics[1] as $key => $value) {
                        $array_key = explode(":", $value);

                        $stats_arr[strip_tags($array_key[0])] = strip_tags($array_key[1]);
                    }

                }


                // print_r($stats_arr);exit;
                // $env['statistics'] = $stats_arr;

                $env['title'] = $title;
                $env['url'] = $link_url;
                $env['desc'] = $desc;

                $nu = rand(1,7387483);
                $htmlData .= '<div class="col-md-6 col-lg-6 col-xl-3">
        
                    <div class="card">
                        <div class="card-body">
                            <h4 class="card-title  mt-0"><i class="to-ebay"></i></h4>
                            <h6 class="card-subtitle font-14 text-muted">
                                    <input type="checkbox" data-description = ""  data-product_id = "clickbank-'.$nu.'" data-source="clickbank" data-title="'.base64_encode($title).'" data-price="-" data-currency="-" data-thumbnail ="'.base_url('assets/images/gallery/work-6.jpg').'" data-buynow="'.$link_url.'" class="importProduct"></h6>
                        </div>
                        <img class="img-fluid" src="'.base_url('assets/images/gallery/work-6.jpg').'" alt="Card image cap">
                        <div class="card-body">
                        <h6 class="card-subtitle font-14 text-muted">Category : <span class="text-danger">'.$stats_arr['Cat'].'</span></h6><br>
                            <p class="card-text">'.$title.'</p>
                            
                            <p><span class="text-danger">Gravity : </span>'.$stats_arr['Grav'].' <a href="'.$link_url.'" data-toggle="tooltip" title="View Product" class="float-right text-muted" target="_blank"><i class="ti-eye"></i></a></p>
                            
                                   <p class="text-center"> <a href="javascript:void(0)" data-description = "" class="addProduct btn btn-primary" data-product_id = "clickbank-'.$nu.'" data-source="clickbank" data-title="'.base64_encode($title).'" data-price="-" data-currency="-" data-thumbnail ="'.base_url('assets/images/gallery/work-6.jpg').'" data-buynow="'.$link_url.'">Import
                                    </a></p>
                            
                        </div>
                    </div>

                 </div>';
                
                $items[] = $env;
            }

            // $htmlData .= "</div>";
                $result['status'] = '200';
                $result['response'] = $htmlData;
        }

        echo json_encode($result);
    }


    /**
        *INSERT OR UPDATE MANUAL AND API PRODUCTS
        *
        * @filesource 
        * ACTION 0-API, 1-Manual Insert, 2-Update product
    */
    public function insertProduct($action = 0)
    {

        $a = array();
        // echo $action;exit;
        $thumbnail = $_POST['thumbnail'];
        $check_product = $this->app_lib->checkExit('products',array('subdomain_id' => $_POST['subdomain_id'], 'asin_id' => $_POST['asin_id']));

       
        if($action == 0 && $check_product == 0)
        {
            if($_POST['source'] == 'ebay')
            {
                $asin_id = $_POST['asin_id'];

                $ebayData = $this->app_lib->fetchTableData('settings',array("user_id"=>$this->user_id,'meta_type'=>'ebay'));

                $api_keys = unserialize($ebayData[0]['Data']->meta_data);
                $site_id = 0;
                $appid = $api_keys['ebayappid'];


                $apicall = "http://open.api.ebay.com/shopping?callname=GetSingleItem&responseencoding=XML&appid=" .$appid . "&siteid=" . $site_id . "&version=515&ItemID=" . $asin_id . "&IncludeSelector=Description,Details,Variations,ListingStatusCodeType";                                            
                        $xml = $this->app_lib->processURL($apicall);
                        $tmp_response = simplexml_load_string($xml);

                        // print_r($tmp_response);exit;

                        if(!empty($tmp_response) && $tmp_response->Item->ItemID == $asin_id)
                        {
                            $description = (string)$tmp_response->Item->Description;
                            $description = str_ireplace('&nbsp;',' ',$description);

                            // echo $description;exit;

                            $description = preg_replace('/(<[^>]+) style=".*?"/i', '$1', $description);


                            $product_data = array(

                                'description' => base64_encode($description),
                                'feature' => base64_encode(''),
                                
                            );

                            $thumbnail=$tmp_response->Item->PictureURL[0];
                            if (strpos($thumbnail,'?set_id') !== false){
                                $thumbnail = substr($thumbnail, 0, strpos($thumbnail, '?set_id'));    
                            }

                        }}
            else
            {


                $asin_id = $_POST['asin_id'];


                $product_data = array(

                    'description' => $_POST['description'],
                    'feature' => base64_encode(''),
                    
                );
            }

            $data = array(
                'title' => base64_decode($_POST['title']),
                'asin_id' => $_POST['asin_id'],
                'currency' => $_POST['currency'],
                'price' => $_POST['price'],
                'buy_now' => $_POST['buynow'],
                'thumbnail' => $thumbnail,
                'status' => 1,
                'product_data' => serialize($product_data),
                'subdomain_id' => $_POST['subdomain_id'],
                'type' => $_POST['source']
            );

            $this->app_lib->insertTable('products',$data);

        }
        else if($action == 1 || $action == 2)
        {
            $product_id = $_POST['product_id'];

            $product_data = array(

                'description' => $_POST['description'],
                'feature' => $_POST['feature'],
                
            );

            if(!empty($product_id))
            {
                $tabledata = $this->app_lib->fetchTableData('products',array('id'=>$product_id));

                // print_r($tabledata);
                if($tabledata[0]['Data']->dataType==1)
                {
                    $dataProduct = $tabledata[0]['Data']->product_data;

                    if(!empty($dataProduct))
                    {
                        $dataProduct = json_decode($dataProduct,true);
                         // print_r($dataProduct);
                        

                    }
                    else
                    {
                        $dataProduct = $tabledata[0]['Data']->product_data;

                        if(!empty($dataProduct))
                        {
                            $dataProduct = unserialize($dataProduct);
                        }
                    }


                    foreach ($dataProduct as $key => $value) {
                        if($key != 'description' && $key!= 'feature')
                        {
                            $product_data[$key] = $value;
                        }
                        // if(!array_key_exists('description', ))
                    }

                }
            }

            $data = array(
                'title' => $_POST['title'],
                'asin_id' => $_POST['asin_id'],
                'currency' => $_POST['currency'],
                'price' => $_POST['price'],
                'buy_now' => $_POST['buy_now'],
                'thumbnail' => $_POST['thumbnail'],
                'status' => $_POST['status'],
                'product_data' => serialize($product_data),
                'dataType' => 0,
                'type' => $_POST['type']
            );

            if(empty($product_id))
            {
                $subdomain_id = $_POST['subdomain_id'];
                $data['subdomain_id'] = $subdomain_id;
                
                $post_id = $this->app_lib->insertTable('products',$data);

                $a = array('status' => 200,'link' => base_url('singleproduct/').$subdomain_id.'/'.$post_id);
            } 
            else
            {
                // update existing post

                $where = array(
                    'id' => $product_id,
                    'subdomain_id' => $_POST['subdomain_id']
                );

                $this->app_lib->updateTable('products',$where,$data);

                $a = array(
                    'status' => 400,
                    'response' => "Product Updated successfully",
                );
            }
        }

            
        echo json_encode($a);
        



    }

    /**
     * Insert Bluk Products
     */
    public function insertBulkProducts()
    {

        $source = $_POST['source'];
        $title = $_POST['title'];
        $price = $_POST['price'];
        $currency = $_POST['currency'];
        $thumbnail = $_POST['thumbnail'];
        $buynow = $_POST['buynow'];
        $subdomain_id = $_POST['subdomain_id'];
        $asin_id = $_POST['asin_id'];
        $description = $_POST['data-description'];

        $ebayData = $this->app_lib->fetchTableData('settings',array("user_id"=>$this->user_id,'meta_type'=>'ebay'));
        $api_keys = unserialize($ebayData[0]['Data']->meta_data);
        foreach ($title as $key => $value) {
            

            $checkExit = $this->app_lib->checkExit('products',array('subdomain_id' => $subdomain_id,'asin_id' => $asin_id[$key]));
            // echo $checkExit;
            if($checkExit==0)
            {   
                if($source[$key] == 'ebay')
                {
                    


                    $product_id = $asin_id[$key];

                    
                    $site_id = 0;
                    $appid = $api_keys['ebayappid'];


                    $apicall = "http://open.api.ebay.com/shopping?callname=GetSingleItem&responseencoding=XML&appid=" .$appid . "&siteid=" . $site_id . "&version=515&ItemID=" . $product_id . "&IncludeSelector=Description,Details,Variations,ListingStatusCodeType";                                         
                            $xml = $this->app_lib->processURL($apicall);
                            $tmp_response = simplexml_load_string($xml);

                    if(!empty($tmp_response) && $tmp_response->Item->ItemID == $asin_id[$key])
                    {
                        $e_description = (string)$tmp_response->Item->Description;
                        $e_description = str_ireplace('&nbsp;',' ',$e_description);

                        // echo $description;exit;

                        $e_description = preg_replace('/(<[^>]+) style=".*?"/i', '$1', $e_description);


                        $product_data = array(

                            'description' => base64_encode($e_description),
                            'feature' => base64_encode(''),
                            
                        );
                        // print_r( $tmp_response->Item->PictureURL);exit;
                        $e_thumbnail = $tmp_response->Item->PictureURL[0];
                        if (strpos($e_thumbnail,'?set_id') !== false){
                            $thumbnail[$key] = substr($e_thumbnail, 0, strpos($e_thumbnail, '?set_id'));    
                        }

                    }
                    
                }
                else
                {
                    $product_data = array(

                        'description' => $description[$key],
                        'feature' => base64_encode(''),
                        
                    );
                }


                $data = array(
                            'title' => base64_decode($title[$key]),
                            'asin_id' => $asin_id[$key],
                            'currency' => $currency[$key],
                            'price' => $price[$key],
                            'buy_now' => $buynow[$key],
                            'thumbnail' => $thumbnail[$key],
                            'status' => 1,
                            'product_data' => serialize($product_data),
                            'subdomain_id' => $subdomain_id,
                            'type' => $source[$key]
                        );

                $this->app_lib->insertTable('products',$data);
            }
            else
            {

            }
        }
    }

    
    /*
        Delete the products by ID
    */
    public function deleteProduct()
    {
        $this->app_lib->deleteTableData('products',['id' => $_POST['product_id']]);
    }


    /*
        Upload products Image
    */
    public function uploadProductImage()
    {
        $user = $this->ion_auth->user()->row();
		$user_id = $user->id;

        $this->load->library('s3_lib');   
        echo json_encode($this->s3_lib->imageUpload($user_id));
    }

    

	

}
