<?php
defined('BASEPATH') OR exit('No direct script access allowed');

require './inc/vendor/autoload.php';
use GuzzleHttp\Client;
use League\Oauth2\Client\Provider\GenericProvider;

class Settings extends CI_Controller
{
	public $clients =  array();
	
	function __construct()
	{
		parent::__construct();

		$this->load->library('ion_auth');
		$this->load->model('Datamodel');
		$this->load->model('Ion_auth_model');
		
		if(!$this->ion_auth->logged_in())
		{
			redirect('login');
		}
		else
		{
			$user = $this->ion_auth->user()->row();
			$this->user_id = $user->id;
   
		   $user_client = $this->Datamodel->fetchCLients();
			if (!empty($user_client)) 
			{
				foreach ($user_client as $key => $value) {
					array_push($this->clients, $value['users']->id);
				}	
			}
		   
		   $this->data['clients'] = $this->clients;
		   $this->data['subdomains'] = $this->Datamodel->fetchAllSubdomain($this->data['clients']);
		}

		

		// $u = $this->ion_auth->user()->row();
		// $whr['user_id'] = $u->id;
		// $this->data['settings'] = $this->Datamodel->fetchTableData('whitelabel_settings', $whr, 'image_name, image_path, footer_text, brand_text');
	}

	public function index()
	{
		$this->data['PageTitle']='Settings';
		$this->load->view('pages/settings', $this->data);
	}

	public function auto_responder()
	{
		$u = $this->ion_auth->user()->row();
		$user_id = $u->id;
		$getresponse=array('user_id'=>$user_id,'respondertype'=>1,'status'=>1);
		$activecampaign=array('user_id'=>$user_id,'respondertype'=>2,'status'=>1);
		$mailchimp=array('user_id'=>$user_id,'respondertype'=>3,'status'=>1);
		$aweber=array('user_id'=>$user_id,'respondertype'=>4,'status'=>1);
		$icontact=array('user_id'=>$user_id,'respondertype'=>5,'status'=>1);
		$gtw=array('user_id'=>$user_id,'respondertype'=>6,'status'=>1);

		$this->data['getresponse']=$this->Datamodel->fetchTableData('autoresponder',$getresponse);
		$this->data['activecampaign']=$this->Datamodel->fetchTableData('autoresponder',$activecampaign);
		$this->data['mailchimp']=$this->Datamodel->fetchTableData('autoresponder',$mailchimp);
		$this->data['aweber']=$this->Datamodel->fetchTableData('autoresponder',$aweber);
		$this->data['icontact']=$this->Datamodel->fetchTableData('autoresponder',$icontact);
		$this->data['webinar']=$this->Datamodel->fetchTableData('autoresponder',$gtw);

		$where=array('user_id'=>$user_id);

		//$this->data['campaigns']=$this->Datamodel->fetchTableData('campaigns',$where);
		$this->data['setting']=$this->Datamodel->fetchTableData('settings',$where);
		//$this->data['whitelabelsettings']=$this->Datamodel->fetchTableData('whitelabel_settings',$where);
		//this->data['tutorialsData'] = $this->Datamodel->getAllwhere_ob('tutorials',array(1=>1),'order_id','ASC');
		$this->data['ActiveTab'] = 'settings';
		$this->data['PageTitle']='Settings';
		$this->load->view("pages/autoresponder/setting",$this->data);
	}

	//open autoresponder innerpage
	public function addresponder($type)
	{
		$u = $this->ion_auth->user()->row();
		$user_id = $u->id;
		if($type=='getresponse'){
			$rtype=1;
		}
		if($type=='activecampaign'){
			$rtype=2;
		}
		if($type=='mailchimp'){
			$rtype=3;
		}
		if($type=='aweber'){
			$rtype=4;
		}
		if($type=='icontact'){
			$rtype=5;
		}
		if($type=='gotowebinar'){
			$rtype=6;
		}
		$this->data[$type]=$this->Datamodel->fetchTableData('autoresponder',array('user_id'=>$user_id,'respondertype'=>$rtype,'status'=>1));
		$this->data["ActiveTab"]='settings';
		$this->data['PageTitle']=$type.' Page';
		$this->load->view('pages/autoresponder/'.$type,$this->data); 
	}

	// Save AutoResponder Settings
	public function saveresponder()
	{
		$u = $this->ion_auth->user()->row();
		$user_id = $u->id;
		$data=array();
		if(isset($_REQUEST['type']))
		{
			$type=$_REQUEST['type'];
			$connect=$_REQUEST['connect'];
			if($connect=='0')
			{
				$status='0';
			}
			else
			{
				$status='1';
			}
			if($_REQUEST['type']=='aweber')
			{				
				//print_r($authData);
				$rtype=4;
				if($status==0)
				{
					$data=array('user_id'=>$user_id,'respondertype'=>$rtype,'param1'=>'','status'=>$status);
				}
				else
				{
					$this->getAweberCred($rtype,$user_id,$status);
					exit;
				}
			}
			if($_REQUEST['type']=='gotowebinar')
			{
				$rtype=6;
				if($status== 0 )
				{
					$data=array('user_id'=>$user_id,'respondertype'=>$rtype,'param1'=>'','status'=>$status);
				}
				else
				{
					$this->getGtwCred($rtype,$user_id,$status);
					exit;
				}
			}
			if($_REQUEST['type']=='getresponse')
			{
				$apikey=$_REQUEST['apikey'];
				$rtype=1;
				$data=array('user_id'=>$user_id,'respondertype'=>$rtype,'param1'=>$apikey,'status'=>$status);
			}
			if($_REQUEST['type']=='mailchimp')
			{
				$apikey=$_REQUEST['apikey'];
				$rtype=3;
				$data=array('user_id'=>$user_id,'respondertype'=>$rtype,'param1'=>$apikey,'status'=>$status);
			}
			if($_REQUEST['type']=='icontact')
			{
				$apiuser=$_REQUEST['apiuser'];
				$apipass=$_REQUEST['apipass'];
				$appid=$_REQUEST['appid'];
				$rtype=5;
				$data=array('user_id'=>$user_id,'respondertype'=>$rtype,'param1'=>$appid,'param2'=>$apiuser,'param3'=>$apipass,'status'=>$status);
			}
			if($_REQUEST['type']=='activecampaign')
			{
				$appkey=$_REQUEST['apikey'];
				$appurl=$_REQUEST['appurl'];
				$rtype=2;
				$data=array('user_id'=>$user_id,'respondertype'=>$rtype,'param1'=>$appkey,'param2'=>$appurl,'status'=>$status);
			}
			$where = array('user_id'=>$user_id,'respondertype'=>$rtype);
			$RT=$this->Datamodel->checkExit('autoresponder',$where);
			if($RT > 0 )
			{
				$this->Datamodel->updateTable('autoresponder',$where,$data);
			}
			else
			{
				$this->Datamodel->insertTable('autoresponder',$data);
			}
			$this->data[$type]=$this->Datamodel->fetchTableData('autoresponder',array('user_id'=>$user_id,'respondertype'=>$rtype,'status'=>1));

			$this->data["ActiveTab"]='settings';
			$this->data['PageTitle']=$type.' Page';
			$this->load->view('pages/autoresponder/'.$type,$this->data);
		} 
	}

	public function getAweberCred($_rtype = '',$user_id ='',$status =''){
		// echo 'Enter your client id: ';
		if($_rtype !=''){
			$this->session->set_userdata('curr_user_id',$user_id);
			$this->session->set_userdata('rtype',$_rtype);
			$this->session->set_userdata('status',$status);
		}

		$authData=$this->config->item('aweber');
	
		$clientId = $authData['client_id'];

		$redirectUri = site_url('getAweberCred');
		
		$OAUTH_URL = $authData['OAUTH_URL'];
		
		$TOKEN_URL = $authData['TOKEN_URL'];
		
		$code_challenge=$authData['code_challenge'];
		
		$scopes_arr = array(
			'account.read',
			'list.read',
			'list.write',
			'subscriber.read',
			'subscriber.write',
			'email.read',
			'email.write',
			'subscriber.read-extended'
		);
		$scopes=implode("+",$scopes_arr);
		//exit;
		$state='62cdb1ee8a5c40f6ba0d5de1dfa83113';
		
		$authUrl=$OAUTH_URL.'authorize?client_id='.$clientId.'&response_type=code&code_challenge='.$code_challenge.'&code_challenge_method=S256&scope='.$scopes.'&state='.$state.'&redirect_uri='.$redirectUri;
		
		if(isset($_GET['code']))
		{
			$code = $_GET['code'];
			$ch = curl_init();
			// serialize()
			curl_setopt($ch, CURLOPT_URL,$TOKEN_URL."?grant_type=authorization_code&code=$code&redirect_uri=".$redirectUri."&code_verifier=HLBvz1g_bbLZ31kjvlXJ5Rl0W1GgxU8rjYJdQIIEH_Y&client_id=".$clientId);
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false); 
			curl_setopt($ch, CURLOPT_RETURNTRANSFER,true);
			curl_setopt($ch, CURLOPT_POST, true);
			//curl_setopt($ch, CURLOPT_HEADER, true);
			$res = curl_exec($ch);
			curl_close($ch);
	
			$__rtype = $this->session->userdata('rtype');
			$__status = $this->session->userdata('status');
			$__userid = $this->session->userdata('curr_user_id');
			$data=array('user_id'=>$__userid,'respondertype'=>$__rtype,'param1'=>$res,'status'=>$__status);
			$where = array('user_id'=>$__userid,'respondertype'=>$__rtype);
			$RT=$this->Datamodel->checkExit('autoresponder',$where);
			if($RT > 0 ){
				$this->Datamodel->updateTable('autoresponder',$where,$data);
			}else{
				$this->Datamodel->insertTable('autoresponder',$data);
			}
			
			redirect('settings');
			
		}else{
			redirect($authUrl);
		}
		
	}
	
	public function getAweberLists(){

		$authData=$this->config->item('aweber');
		
		define('BASE_URL',$authData['BASE_URL']);
		define('OAUTH_URL',$authData['OAUTH_URL']);
		define('TOKEN_URL',$authData['TOKEN_URL']);
		// Create a Guzzle client
		$client = new GuzzleHttp\Client();
		$ret=array();
		$html='';
		$error='';
		// Load credentials
		if(isset($_REQUEST['refreshtoken']) && isset($_REQUEST['accesstoken'])){
			$accessToken = $_REQUEST['accesstoken'];
			$refreshtoken = $_REQUEST['refreshtoken'];

			if(isset($_REQUEST['selected']) && $_REQUEST['selected'] !=''){
				$prevList=$_REQUEST['selected'];
			}else{
				$prevList= '';
			}

			$this->getAweberRefreshToken($client,$refreshtoken);
			$user = $this->ion_auth->user()->row();
			$user_id = $user->id;
			$rtype=4;
			$data1 = $this->Datamodel->fetchTableData('autoresponder',array('user_id'=>$user_id,'respondertype'=>$rtype));
			$param1=json_decode($data1[0]['Data']->param1,true);
			$refreshtoken = $param1['refresh_token'];
			$accessToken = $param1['access_token'];
			//$accessToken = 'fApSzsFTV4ePtfkE66TD8viDgq2riuTG';
			// get all the accounts entries
			$accounts = $this->getCollection($client, $accessToken, BASE_URL . 'accounts');
			$accountUrl = $accounts[0]['self_link'];

			//print_r($accounts);exit;
			// get all the list entries for the first account
			$listsUrl = $accounts[0]['lists_collection_link'];
			$lists = $this->getCollection($client, $accessToken, $listsUrl);
			//print_r($lists);
			if( !empty($lists) ) {
			//echo '<select>';
				foreach($lists as $list){
					$subsUrl = $list['subscribers_collection_link'];
					$name = $list['name'];
					if($prevList == $subsUrl){
						$html.='<option value="'.$subsUrl.'" selected="selected">'.$name.'</option>';
					}else{
						$html.='<option value="'.$subsUrl.'">'.$name.'</option>';
					}
				}
			}
			else
			{ 
				$error.='Something Went Wrong!';
			}
			//echo $html;
			$ret['html']=$html;
			$ret['error']=$error;
			echo json_encode($ret);die;
		}
	}

	//AutoResponder Function
	public function getAutoResponder(){
		$user = $this->ion_auth->user()->row();
		$user_id = $user->id;
		$rtype=$_REQUEST['rtype'];
		$data1 = $this->Datamodel->fetchTableData('autoresponder',array('user_id'=>$user_id,'respondertype'=>$rtype));
		if($rtype==6){
			$param1=json_decode($data1[0]['Data']->param1,true);
			$data['param1'] = $param1['organizer_key'];
			$data['param2'] = $param1['access_token'];
			$data['param3'] = $param1['refresh_token'];
			$data['param4'] = $user_id;
		}else if($rtype==4){
			$param1=json_decode($data1[0]['Data']->param1,true);
			$data['param1'] = $param1['refresh_token'];
			$data['param2'] = $param1['access_token'];
			$data['param3']= $user_id;
		}else{
			$data['param1'] = $data1[0]['Data']->param1;
			$data['param2'] = $data1[0]['Data']->param2;
			$data['param3']= $data1[0]['Data']->param3;
		}
		
		echo json_encode($data);
		die;	
	}

	public function getWebinarlists(){

		$authData=$this->config->item('webinar');

		define('BASE_URL',$authData['BASE_URL']);

		$ret=array();
		$html='';
		$error='';

		if(isset($_REQUEST['refreshToken']) && isset($_REQUEST['accessToken'])){

			$organizerKey=$_REQUEST['organizerKey'];
			$accessToken=$_REQUEST['accessToken'];
			$refreshToken=$_REQUEST['refreshToken'];	
			if(isset($_REQUEST['selected']) && $_REQUEST['selected'] !=''){
				$prevWebinar=$_REQUEST['selected'];
			}else{
				$prevWebinar= '';
			}
			// $client_id=$authData['client_id'];
			// $client_secret=$authData['client_secret'];
			// $authorize=base64_encode($clinetID.":".$client_secret);

			$this->getGtwRefreshToken($refreshToken);

			$user = $this->ion_auth->user()->row();
			$user_id = $user->id;
			$rtype=6;

			$data1 = $this->Datamodel->fetchTableData('autoresponder',array('user_id'=>$user_id,'respondertype'=>$rtype));
			$param1=json_decode($data1[0]['Data']->param1,true);
			$refreshtoken = $param1['refresh_token'];
			$accessToken = $param1['access_token'];

			$objDateTime = new DateTime('NOW');

			$dt = new DateTime('NOW');
			$dt->setTimezone(new DateTimeZone('UTC'));
			$toTime = $dt->format('Y-m-d\TH:i:s\Z');
			$fromTime = '2020-01-13T00:00:00Z';
			
			$strUrl = BASE_URL . 'organizers/'.$organizerKey.'/webinars?fromTime='.$fromTime.'&toTime='.$toTime.'&size=20';
			
			$ch = curl_init();
		    curl_setopt($ch, CURLOPT_URL, $strUrl);
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false); 
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			// curl_setopt($ch, CURLOPT_POST, true);
			// curl_setopt($ch, CURLOPT_HEADER, true);
			curl_setopt($ch, CURLOPT_HTTPHEADER, array('Accept: application/json', 'Content-Type: application/json', 'Authorization: OAuth oauth_token='.$accessToken));
			$response = curl_exec($ch);
			$info = curl_getinfo($ch);
		  
			curl_close($ch);
		  
		  	// echo 'hii';exit;
			$result = json_decode($response,true);

			// print_r($result);exit;

			if(!empty($result['_embedded']['webinars'])){

				foreach($result['_embedded']['webinars'] as $val){

					$webinarKey=$val['webinarKey'];
					$subject=$val['subject'];
					if($prevWebinar == $webinarKey){
						$html.='<option value="'.$webinarKey.'" selected="selected">'.$subject.'</option>';
					}else{
						$html.='<option value="'.$webinarKey.'">'.$subject.'</option>';
					}
					
				}
			}
			else
			{ 
				$error.='Something Went Wrong!';
			}
			//echo $html;
			$ret['html']=$html;
			$ret['error']=$error;
			echo json_encode($ret);die;		
		}
		
	}

	//get GTW refresh Token
	function getGtwRefreshToken($refreshToken){

		// echo $refreshToken;exit;
		$TOKEN_URL=$this->config->item('TOKEN_URL','webinar');

		$client_id = $this->config->item('client_id','webinar');

		$client_secret=$this->config->item('client_secret','webinar');


		$redirectUri = site_url('getGtwCred');

		$u = $this->ion_auth->user()->row();
		$__userid = $u->id;
		$__rtype=6;
		$authorize=base64_encode($client_id.":".$client_secret);

		$ch = curl_init();
		// serialize()
		curl_setopt($ch, CURLOPT_URL,$TOKEN_URL."?grant_type=refresh_token&refresh_token=$refreshToken");
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false); 
		curl_setopt($ch, CURLOPT_RETURNTRANSFER,true);
		curl_setopt($ch, CURLOPT_POST, true);
		// curl_setopt($ch, CURLOPT_HEADER, true);
		curl_setopt($ch, CURLOPT_HTTPHEADER, array('Accept: application/json', 'Content-Type: application/json', 'Authorization: Basic '.$authorize));
		$res = curl_exec($ch);
		curl_close($ch);

		// print_r($res);

		$where = array('user_id'=>$__userid,'respondertype'=>$__rtype);
		$this->Datamodel->updateTable('autoresponder',$where,array("param1"=>$res));

		// return $res;

	}

	//get aweber refresh token
	function getAweberRefreshToken($client,$refreshtoken){

		$u = $this->ion_auth->user()->row();
		$__userid = $u->id;
		$__rtype=4;
		$clientId = $this->config->item('client_id','aweber');
		$clientSecret = '';
		$response = $client->post(
        TOKEN_URL, [
            'auth' => [
                $clientId, $clientSecret
            ],
            'json' => [
                'grant_type' => 'refresh_token',
                'refresh_token' => $refreshtoken
            ]
        ]
		);
		$body = $response->getBody();
		//$newCreds = json_decode($body, true);
		$data=array('param1'=>$body);
		$where = array('user_id'=>$__userid,'respondertype'=>$__rtype);
		$this->Datamodel->updateTable('autoresponder',$where,$data);
		//print_r($newCreds);
	}

	// public function logo_upload(){


	// 	$user = $this->ion_auth->user()->row();
    //     $userID = $user->id;

	// 	if( !is_dir( 'storage/uploads/logo/'.$userID ) ) {
				
	// 		mkdir('storage/uploads/logo/'.$userID );
		
	// 	}
		
	//    $config['upload_path'] = 'storage/uploads/logo/'.$userID.'/';
				
	//    $config['allowed_types'] =   "gif|jpg|jpeg|png"; 
 
    //    $config['max_size']      =   "2000";
 
    //    $config['max_width']     =   "1200";
 
    //    $config['max_height']    =   "1080";
		
	// 	$config['overwrite']	=	true;
	   
    //    $this->load->library('upload',$config);
 
    //    if(!$this->upload->do_upload('file'))
    //    {
    //        echo $this->upload->display_errors();	
    //    }
	//    else
    //    {
			
	// 		$finfo=$this->upload->data();
			
    //       	// $this->createThumbnail($finfo['file_name']);
	// 	  	$image_name=$finfo['file_name'];
	// 	   	$path= base_url().$config['upload_path'].$image_name;
			
	// 		// $status=1;

	// 		$checkExit=$this->Datamodel->checkExit("whitelabel_settings",array("user_id"=>$userID));
	// 	    if($checkExit > 0){
	// 	    	$this->Datamodel->updateTable("whitelabel_settings",array("user_id"=>$userID),array("image_name"=>$image_name,"image_path"=>$path));
	// 	    }else{
	// 	    	 $insert_id=$this->Datamodel->insertTable("whitelabel_settings",array("image_name"=>$image_name,"image_path"=>$path,"user_id"=>$userID));
	// 	    }
		   
	// 	    echo base_url('storage/uploads/logo/'.$userID.'/'.$image_name);
		    
    //    }
	// }

	// public function whitelabelsettings(){

	// 	$user = $this->ion_auth->user()->row();
    //     $userID = $user->id;

	// 	$checkExit=$this->Datamodel->checkExit("whitelabel_settings",array("user_id"=>$userID));
	// 	if($checkExit > 0){

	// 		 $data=array("footer_text"=>$_REQUEST['footer_text'],"brand_text"=>$_REQUEST['brand_text']);
	// 		$this->Datamodel->updateTable("whitelabel_settings",array("user_id"=>$userID),$data);
	// 	}else{
		    	
	// 	    $data=array("footer_text"=>$_REQUEST['footer_text'],"brand_text"=>$_REQUEST['brand_text'],"user_id"=>$userID);
	// 		$insert_id=$this->Datamodel->insertTable("whitelabel_settings",$data);
	// 	}

	// 	echo "success";
	// }
}