<?php



defined('BASEPATH') OR exit('No direct script access allowed');


class App_lib
{
	public function __construct()
	{
		
		$this->load->model('Datamodel');
	}

	/**
	 * __call
	 *
	 * Acts as a simple way to call model methods without loads of stupid alias'
	 *
	 * @param string $method
	 * @param array  $arguments
	 *
	 * @return mixed
	 * @throws Exception
	 */
	public function __call($method, $arguments)
	{
		// echo $method;exit;

		if (!method_exists( $this->datamodel, $method) )
		{
			throw new Exception('Undefined method User_lib::' . $method . '() called');
		}
		return call_user_func_array( [$this->datamodel, $method], $arguments);
	}



	/**
	 * __get
	 *
	 * Enables the use of CI super-global without having to define an extra variable.
	 *
	 * I can't remember where I first saw this, so thank you if you are the original author. -Militis
	 *
	 * @param    string $var
	 *
	 * @return    mixed
	 */
	public function __get($var)
	{
		return get_instance()->$var;
	}


	public function validateURL($param,$user_id)
    {
        
        $param_data = explode("+", base64_decode($param));
        $subdomain_id = $param_data[1];
        
        if($user_id !=1)
        {
            $where = array(
                'id' => $subdomain_id,
                'user_id' => $user_id
            );
        }
        else
        {
            $where = array(
                'id' => $subdomain_id,
            );
        }

        $checkValid = $this->Datamodel->checkExit('subdomains',$where);

        return $checkValid ? $subdomain_id : 0;
        
    }


    public function _render_page($page,$data)
    {
        $this->load->view('shared/header',$data);
        $this->load->view($page,$data);
        $this->load->view('shared/antispam',$data);

    }

    public function processURL($frameurl)
	{
		// echo $frameurl;
			$ch = curl_init();
	        curl_setopt_array($ch, array(
	        CURLOPT_URL => trim($frameurl),
	        CURLOPT_RETURNTRANSFER => true,
	        CURLOPT_SSL_VERIFYPEER => false,
	        CURLOPT_SSL_VERIFYHOST => 2
	        ));

	        $result = curl_exec($ch);
	        curl_close($ch);

	        // print_r($result);exit;
	        return $result;
	}


	public function removeQuotes($string)
	{
		return preg_replace("/[^a-zA-Z0-9]+/", " ", html_entity_decode($string, ENT_QUOTES));
    }

    public function convertURLs($string)
	{
	    $url = '/(http|https|ftp|ftps)\:\/\/[a-zA-Z0-9\-\.]+\.[a-zA-Z]{2,3}(\/\S*)?/';   
	    return preg_replace($url, '<a href="$0" target="_blank" title="$0">$0</a>', $string);
	} 

    
}


?>