<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class Datamodel extends CI_Model {
    function __construct()
    {
        parent::__construct();
        
        $this->load->database();
        $this->load->library('session');
        $this->load->library('ion_auth');
  	
      
    }
    
 	//searchin site 
	
	public function getSiteList($userID = '', $search = '',$limit='',$start='') {
	 
     $user = $this->ion_auth->user()->row();
     $userID = $user->id;
	 $this->db->from('stories')->where("title like '%".$search."%' and user_id='".$userID."'")->join('users', 'stories.user_id = users.id');
	 if ($limit !== '' && $start !== ''){
      $this->db->limit($limit,$start*$limit);
      //print($start*$limit);
      //exit;
     }
	 $query=$this->db->get();
	
     $res = $query->result();
  
     
  
  $allSites = array();//array holding all sites and associated data
  
  
  
	foreach( $res as $site ) {
  
   $temp = array();
   
   $temp['siteData'] = $site;
   
   $allSites[] = $temp;
  
	}
  
 	 return $allSites;
	}
	public function getAllStories($subdomain_id)
	{
		$user = $this->ion_auth->user()->row();
		$userID = $user->id;
		
			$this->db->from('stories');
			if(!empty($subdomain_id))
			{
				$this->db->where("subdomain_id",$subdomain_id);
			}
			$this->db->where('user_id ',$userID );

			$query = $this->db->get();
			if ($query->num_rows() > 0) {
			$allSites = array();
			foreach ($query->result() as $row) {
			$data = array();
			$data['siteData']=$row;
			$allSites[]=$data;
			}

			return $allSites;
		}
		return false;		
	}
	
	/*
	
		fetching all data from stories table
	
	*/
	
	
	public function fetch_all_data($limit = '', $start = '',$subdomain_id = '' ) {
	$user = $this->ion_auth->user()->row();
    $userID = $user->id;
	
	$this->db->from('stories');
	if(!empty($subdomain_id))
	{
		$this->db->where("stories.subdomain_id",$subdomain_id);
	}
	$this->db->order_by("stories.story_id", "desc");
	$this->db->join('users', 'stories.user_id = users.id');
	
	 if ($limit !== '' && $start !== ''){
      $this->db->limit($limit,$start*$limit);
      // print($start*$limit);
      // exit;
     }
     // print_r($this->db->last_query());   exit;
	$query = $this->db->get();
	if ($query->num_rows() > 0) {
	$allSites = array();
	foreach ($query->result() as $row) {
	$data = array();
	$data['siteData']=$row;
	$data['siteData']->views=$this->getAllViews($row->story_id);
	$data['siteData']->unique=$this->getAllUniqueViews($row->story_id);
	$allSites[]=$data;
	}

	return $allSites;
	}
	return false;
	}	
	public function record_count_all($subdomain_id = null){
		
		$user = $this->ion_auth->user()->row();
		$userID = $user->id;
		if(!empty($subdomain_id))
		{
			$this->db->where("stories.subdomain_id",$subdomain_id);
		}
		return $this->db->join('users', 'stories.user_id = users.id')->count_all_results("stories");
		
	}				
	public function getAllViews($id){

		return $this->db->where('story_id ',$id)->count_all_results("analytics");
		
	}
	public function getTotalLeads($id){

		return $this->db->where('story_id ',$id)->count_all_results("locking_leads");
		
	}
	public function getAllSocial($id){

		return $this->db->where('story_id ',$id)->where('social_impressions',1)->count_all_results("analytics");
		
	}
	public function checkSite($name){
    $user = $this->ion_auth->user()->row();
    $userID = $user->id;
		return $this->db->where('site_name ',$name)->where('user_id <>',$userID)->count_all_results("appearance");
		
	}	
	public function getAllUniqueViews($id){

		return $this->db->distinct()->select('ip_address')->where('story_id',$id)->count_all_results("analytics");
		
	}
	public function checkUserType($id){

		$views = $this->db->where('story_id',$id)->where('ip_address',$_SERVER['REMOTE_ADDR'])->count_all_results("content_locking");
		if($views == 0)
		{
			return 'new';
		}else
		{
			return 'returning';
		}
		
	}	
	public function checkUserPoll($id){

		$views = $this->db->where('story_id',$id)->where('ip_address',$_SERVER['REMOTE_ADDR'])->count_all_results("poll_options");
		if($views == 0)
		{
			return 'new';
		}else
		{
			return 'returning';
		}
		
	}	
	public function getAverageTimeSpent($id){

		$query = $this->db->select('AVG(timespent) as timespents')->where('story_id',$id)->get("analytics");
			if ($query->num_rows() > 0) {
			$allSites = array();
			foreach ($query->result() as $row) {
			$data = array();
			$data['siteData']=$row;
			$allSites[]=$data;
			}

			$avgTime = $allSites[0]['siteData']->timespents;
			
			$hours = floor($avgTime / 60);
			$minutes = ((int)$avgTime % 60);
			return $hours.':'.$minutes;
			}
			return false;		
		
	}
	//fetching data from db table
	
	public function fetch_data($limit = '', $start = '',$subdomain_id = '' ) {
	 
	
    $user = $this->ion_auth->user()->row();
    $userID = $user->id;
	
	$parent_user_id = $user->parent_user_id;

		if($parent_user_id!=1)
		{
			$userID = $parent_user_id;
		}
	
	
   
	$this->db->from('stories');
	$this->db->order_by("stories.story_id", "desc");
	if(!empty($subdomain_id))
	{
		$this->db->where("stories.subdomain_id",$subdomain_id);
	}
	$this->db->join('users', 'stories.user_id = users.id');

	$this->db->where('users.id',$userID);
	 if ($limit !== '' && $start !== ''){
      $this->db->limit($limit,$start*$limit);
      //print($start*$limit);
      //exit;
     }
	$query=$this->db->get();
	
	if ($query->num_rows() > 0) {
	
	$allSites = array();
	foreach ($query->result() as $row) {
	$data = array();
	$data['siteData']=$row;
	$allSites[]=$data;
	}

	return $allSites;
	}
	return false;
	}

	//fetching data from db table
	
	public function getFrameDetail($id) 
	{

	$this->db->from('stories');
	$this->db->where('story_id',$id);
	$query=$this->db->get();
	
	if ($query->num_rows() > 0) {
	
	$allSites = array();
	foreach ($query->result() as $row) {
	$data = array();
	$data['siteData']=$row;
	$allSites[]=$data;
	}

	return $allSites;
	}
	return false;
	}	
		
	public function fetchAllSettings($subdomain_id) {
		
	$user = $this->ion_auth->user()->row();
	$userID = $user->id;  
	
	$parent_user_id = $user->parent_user_id;

	if($parent_user_id!=1)
	{
		$userID = $parent_user_id;
	}

	$this->db->from('appearance');
	$this->db->where("subdomain_id",$subdomain_id);



	$this->db->where('user_id',$userID);
	$query=$this->db->get();
	
	if ($query->num_rows() > 0) {
	
	$allSites = array();
	foreach ($query->result() as $row) {
	$data = array();
	$data['siteData']=$row;
	$allSites[]=$data;
	}

	return $allSites;
	}
	return false;
	}
	public function fetchAllSettingsID($id) {
 
	$this->db->from('appearance');
	$this->db->where('user_id',$id);
	$query=$this->db->get();
	
	if ($query->num_rows() > 0) {
	
	$allSites = array();
	foreach ($query->result() as $row) {
	$data = array();
	$data['siteData']=$row;
	$allSites[]=$data;
	}

	return $allSites;
	}
	return false;
	}	
	
	//fetching data from db table
	
	public function getWpSite($id) {

	$this->db->from('xmlrpc_details');
	$this->db->where('id',$id);
	$query=$this->db->get();
	
	if ($query->num_rows() > 0) {
	
	$allSites = array();
	foreach ($query->result() as $row) {
	$data = array();
	$data['siteData']=$row;
	$allSites[]=$data;
	}

	return $allSites;
	}
	return false;
	}	
	//fetching data from db table
	
	public function getWpSites() {
		
	$user = $this->ion_auth->user()->row();
	$userID = $user->id;  
	$this->db->from('xmlrpc_details');
	$this->db->where('user_id',$userID);
	$query=$this->db->get();
	
	if ($query->num_rows() > 0) {
	
	$allSites = array();
	foreach ($query->result() as $row) {
	$data = array();
	$data['siteData']=$row;
	$allSites[]=$data;
	}

	return $allSites;
	}
	return false;
	}
	public function getAmazonKeys() {
		
		$user = $this->ion_auth->user()->row();
		$userID = $user->id;  
		$this->db->from('amazon_keys');
		$this->db->where('user_id',$userID);
		$query=$this->db->get();
		
		if ($query->num_rows() > 0) {
		
		$allSites = array();
		foreach ($query->result() as $row) {
		$data = array();
		$data['siteData']=$row;
		$allSites[]=$data;
		}

		return $allSites;
		}
		return false;
	}

	
	public function insertYouzign($data)
	{
		$user = $this->ion_auth->user()->row();
		$userID = $user->id;  

		$parent_user_id = $user->parent_user_id;

		if($parent_user_id!=1)
		{
			$userID = $parent_user_id;
		}


		$data['user_id'] = $userID;
		$this->db->insert("youzign",$data);
	}


	public function updateYouzign($data)
	{
		$user = $this->ion_auth->user()->row();
		$userID = $user->id;  


		$parent_user_id = $user->parent_user_id;

		if($parent_user_id!=1)
		{
			$userID = $parent_user_id;
		}

		$this->db->where('user_id',$userID);	
		$this->db->update("youzign",$data);
	}

	public function getYouzign()
	{
		$user = $this->ion_auth->user()->row();
		$userID = $user->id;  

		$parent_user_id = $user->parent_user_id;

		if($parent_user_id!=1)
		{
			$userID = $parent_user_id;
		}


		$this->db->from('youzign');
		$this->db->where('user_id',$userID);
		$query=$this->db->get();
		
		if ($query->num_rows() > 0) {
		
		$allSites = array();
		foreach ($query->result() as $row) {
		$data = array();
		$data['youzignData']=$row;
		$allSites[]=$data;
		}

		return $allSites;
		}
		return false;
	}	
	
	public function getAmazonKeysUser($user) {

	$this->db->from('amazon_keys');
	$this->db->where('user_id',$user);
	$query=$this->db->get();
	
	if ($query->num_rows() > 0) {
	
	$allSites = array();
	foreach ($query->result() as $row) {
	$data = array();
	$data['siteData']=$row;
	$allSites[]=$data;
	}

	return $allSites;
	}
	return false;
	}

	public function getFacebookPages() {
		
	$user = $this->ion_auth->user()->row();
	$userID = $user->id;  
	$this->db->from('fb_settings');
	$this->db->where('user_id',$userID);
	$query=$this->db->get();
	
	if ($query->num_rows() > 0) {
	
	$allSites = array();
	foreach ($query->result() as $row) {
	$data = array();
	$data['siteData']=$row;
	$allSites[]=$data;
	}
	return $allSites;
	}
	return false;
	}	
	public function getPageDetails($id) {
		
	$user = $this->ion_auth->user()->row();
	$userID = $user->id;  
	$this->db->from('fb_settings');
	$this->db->where('user_id',$userID);
	$this->db->where('page_id',$id);
	$query=$this->db->get();
	
	if ($query->num_rows() > 0) {
	
	$allSites = array();
	foreach ($query->result() as $row) {
	$data = array();
	$data['siteData']=$row;
	$allSites[]=$data;
	}

	return $allSites;
	}
	return false;
	}	
	//fetching data from db table
	
	public function getTrackingCode() {
		
	$user = $this->ion_auth->user()->row();
	$userID = $user->id;  
	$this->db->from('tracking_codes');
	$this->db->where('user_id',$userID);
	$query=$this->db->get();
	
	if ($query->num_rows() > 0) {
	
	$allSites = array();
	foreach ($query->result() as $row) {
	$data = array();
	$data['siteData']=$row;
	$allSites[]=$data;
	}

	return $allSites;
	}
	return false;
	}

	public function getTrackingCodeId($user) {
  
	$this->db->from('tracking_codes');
	$this->db->where('user_id',$user);
	$query=$this->db->get();
	
	if ($query->num_rows() > 0) {
	
	$allSites = array();
	foreach ($query->result() as $row) {
	$data = array();
	$data['siteData']=$row;
	$allSites[]=$data;
	}

	return $allSites[0]['siteData']->tracking_code;
	}
	return '';
	}	
	//counting all records in db table	
	public function record_count($subdomain_id = '') {
		 $user = $this->ion_auth->user()->row();
		 $userID = $user->id;
		 if(!empty($subdomain_id))
	{
		$this->db->where("stories.subdomain_id",$subdomain_id);
	}
		return $this->db->join('users', 'stories.user_id = users.id')->where('users.id',$userID)->count_all_results("stories");
		
	}
	public function checkAppearance($subdomain_id) {
		 $user = $this->ion_auth->user()->row();
		 $userID = $user->id;

		$parent_user_id = $user->parent_user_id;

		if($parent_user_id!=1)
		{
			$userID = $parent_user_id;
		}

		 $this->db->where("subdomain_id",$subdomain_id);
		$this->db->where('user_id',$userID);
		return  $this->db->count_all_results("appearance");
		
	}


	public function checkAutoresponder($subdomain_id,$mainType)
	{
		$user = $this->ion_auth->user()->row();
		 $userID = $user->id;

		$parent_user_id = $user->parent_user_id;

		if($parent_user_id!=1)
		{
			$userID = $parent_user_id;
		}
		 $this->db->where("subdomain_id",$subdomain_id);
		$this->db->where('user_id',$userID);
		$this->db->where("mainType",$mainType);
		return  $this->db->count_all_results("autoresponder");
	}


	public function checkprivacyTerm($subdomain_id) {
		 $user = $this->ion_auth->user()->row();
		 $userID = $user->id;
		 $this->db->where("subdomain_id",$subdomain_id);
		// $this->db->where('user_id',$userID);
		return  $this->db->count_all_results("termspolicy");
		
	}


	public function insertAutoresponderSettings($data,$subdomain_id,$mainType)
	{
		$user = $this->ion_auth->user()->row();
		$userID = $user->id;

		$parent_user_id = $user->parent_user_id;

		if($parent_user_id!=1)
		{
			$userID = $parent_user_id;
		}

		$data['user_id'] = $userID;
		$data['mainType'] = $mainType;

		$data['subdomain_id'] = $subdomain_id;
		$this->db->insert("autoresponder",$data);
	}


	public function updateAutoresponderSettings($array,$subdomain_id,$mainType)
	{
		$user = $this->ion_auth->user()->row();
		 $userID = $user->id;

		 $parent_user_id = $user->parent_user_id;

		if($parent_user_id!=1)
		{
			$userID = $parent_user_id;
		}

		 $this->db->where("user_id",$userID);
		 $this->db->where("mainType",$mainType);
		 $this->db->where("subdomain_id",$subdomain_id);
		 $this->db->update("autoresponder",$array);

	}


	public function fetchAutoresponder($subdomain_id,$mainType)
	{
		$user = $this->ion_auth->user()->row();
		$userID = $user->id;  
		$this->db->from('autoresponder');
		$this->db->where("mainType",$mainType);

		$this->db->where("subdomain_id",$subdomain_id);
		$this->db->where('user_id',$userID);
		$query=$this->db->get();

		// echo $this->db->last_query();exit;
		
		if ($query->num_rows() > 0) {
		
			return $query->result()[0];	
		}

		
		return false;
	}
	
	public function insertCampaign($title,$description,$image,$totalBlocks,$content,$tags,$subdomain_id,$type)
	{
		$u = $this->ion_auth->user()->row();
		$user_id = $u->id;	
		$parent_user_id = $u->parent_user_id;

		if($parent_user_id!=1)
		{
			$user_id = $parent_user_id;
		}

		$data['title'] = $title ;
		$data['description'] = $description ;
		$data['image'] = $image ;
		$data['items_loaded'] = $totalBlocks ;
		$data['draf_content'] =  $content ;
		$data['date_created'] =  time() ;
		$data['user_id'] = $user_id;
		$data['tags'] = $tags;
		$data['subdomain_id'] = $subdomain_id;
		$data['type'] = $type;
		$this->db->insert('stories', $data);
		return $this->db->insert_id();		
		
	}

	public function insertAppearanceSettings($formdata)
	{
		$u = $this->ion_auth->user()->row();
		$user_id = $u->id;		

		$parent_user_id = $u->parent_user_id;

		if($parent_user_id!=1)
		{
			$user_id = $parent_user_id;
		}

		$formdata['user_id'] = $user_id;
		$this->db->insert('appearance', $formdata);
		// $this->updateSubdomain($formdata['site_name']);	
		return $this->db->insert_id();		
		
	}

	public function insertPTSettings($formdata)
	{
		$u = $this->ion_auth->user()->row();
		$user_id = $u->id;	


		$parent_user_id = $u->parent_user_id;

		if($parent_user_id!=1)
		{
			$user_id = $parent_user_id;
		}

		$formdata['user_id'] = $user_id;
		$this->db->insert('termspolicy', $formdata);
		// $this->updateSubdomain($formdata['site_name']);	
		return $this->db->insert_id();		
	}


	public function updateAppearanceSettings($formdata)
	{
		$u = $this->ion_auth->user()->row();
		$user_id = $u->id;		
		$subdomain_id = $formdata['subdomain_id'];
		unset($formdata['subdomain_id']);
		//	$formdata['user_id'] = $user_id;
		// print_r($formdata);exit;
		

		$this->db->where("subdomain_id",$subdomain_id);
		// $this->db->where('user_id', $user_id);


		$this->db->update('appearance', $formdata);
		// $this->updateSubdomain($formdata['site_name']);	
	}

	public function updatePTSettings($formdata)
	{
		$u = $this->ion_auth->user()->row();
		$user_id = $u->id;		
		$subdomain_id = $formdata['subdomain_id'];
		unset($formdata['subdomain_id']);
		//	$formdata['user_id'] = $user_id;
		// print_r($formdata);exit;
		

		$this->db->where("subdomain_id",$subdomain_id);
		// $this->db->where('user_id', $user_id);


		$this->db->update('termspolicy', $formdata);
		// $this->updateSubdomain($formdata['site_name']);	
	}

	public function checkBannerAppearance($story_id) {
		
		return $this->db->where('story_id',$story_id)->count_all_results("ad_banner");
		
	}
	public function insertBannerSettings($formdata)
	{
		$u = $this->ion_auth->user()->row();
		$user_id = $u->id;		
		$formdata['user_id'] = $user_id;
		// print_r($formdata);exit;

		$this->db->insert('ad_banner', $formdata);
		
		return $this->db->insert_id();		
		
	}
	public function updateBannerSettings($formdata)
	{
		$u = $this->ion_auth->user()->row();
		$user_id = $u->id;	
		$data=array(
			'user_id' => $user_id,
			'story_id' => $formdata['story_id'] 
		);	
		$this->db->where($data);
		$this->db->update('ad_banner', $formdata);
	}
	public function updateSubdomain($sitename)
	{
		$u = $this->ion_auth->user()->row();
		$user_id = $u->id;		

		$this->db->where('id', $user_id);
		$data['subdomain'] = $sitename;
		$this->db->update('users', $data);
	}
	public function insertSite($url,$username,$password)
	{
		$u = $this->ion_auth->user()->row();
		$user_id = $u->id;		
		$data['url'] = $url ;
		$data['user_id'] = $user_id ;
		$data['username'] = $username ;
		$data['password'] = $password ;

		$this->db->insert('xmlrpc_details', $data);
		return $this->db->insert_id();		
		
	}
	public function insertAmazon($country,$tracking_id,$access_key,$secret_key)
	{
		$u = $this->ion_auth->user()->row();
		$user_id = $u->id;	

		$parent_user_id = $u->parent_user_id;

		if($parent_user_id!=1)
		{
			$user_id = $parent_user_id;
		}


		$data['user_id'] = $user_id ;
		$data['country'] = $country ;
		$data['tracking_id'] = $tracking_id ;
		$data['api_key'] = $access_key ;
		$data['secret_key'] = $secret_key ;

		$check = $this->db->where('user_id',$user_id)->count_all_results("amazon_keys");
		if($check == 0)
		{
		$this->db->insert('amazon_keys', $data);

		}else
		{
		$this->db->update('amazon_keys', $data);
		$this->db->where('user_id', $user_id);
			
		}
		return $this->db->insert_id();		
		
	}
	

	public function updateCampaign($title,$description,$image,$totalBlocks,$content,$campaign_id,$tags,$category,$subdomain_id,$type,$status)
	{
		$u = $this->ion_auth->user()->row();
		$user_id = $u->id;		
		$data['title'] = $title;
		$data['description'] = $description;
		$data['date_created'] =  time() ;

		$data['image'] = $image;
		$data['tags'] = $tags;
		$data['items_loaded'] = $totalBlocks;
		$data['draf_content'] =  $content; 
		// $data['user_id'] = $user_id;
		$data['categories'] = $category; 
		$data['type'] = $type;
		$data['status'] = $status;
		$where = array('story_id' => $campaign_id, 'subdomain_id' => $subdomain_id);
    	$this->db->where($where);
    	
    	$this->db->update('stories', $data);
	}	


	public function makePublish($campaign_id,$content)
	{
		$this->db->where("story_id",$campaign_id);
		$data['status'] = 2;
		$data['content'] = $content;
		$data['draf_content'] = $content;
		$this->db->update("stories",$data);
	}

	public function updateWpSingleSite($id,$username,$password)
	{
	
		$data['username'] = $username;
		$data['password'] = $password;

    	$this->db->where('id', $id);
    	$this->db->update('xmlrpc_details', $data);
	}
	public function deleteStory($id)
	{
		$this->db->where('story_id', $id);

		$this->db->delete('stories');
		
	}
	public function deleteWpSingleSite($id)
	{
		$this->db->where('id', $id);

		$this->db->delete('xmlrpc_details');
		
	}
	public function insertTrackingCode($code)
	{
		$u = $this->ion_auth->user()->row();
		$user_id = $u->id;	

		$parent_user_id = $u->parent_user_id;

		if($parent_user_id!=1)
		{
			$user_id = $parent_user_id;
		}

		$check = $this->db->where('user_id',$user_id)->count_all_results("tracking_codes");
		if($check == 0)
		{
			$data['tracking_code'] = $code ;
			$data['user_id'] = $user_id ;

			$this->db->insert('tracking_codes', $data);			
		}
		else
		{
			$data['tracking_code'] = $code;

			$this->db->where('user_id', $user_id);
			$this->db->update('tracking_codes', $data);			
		}	
		
	}
	
	public function checkVote($story_id,$ip)
	{
		$this->db->where('story_id',$story_id);
		$this->db->where('ip_address',$ip);
		$check = $this->db->count_all_results("poll_options");
		if($check == 0)
		{
			return true;
		}else
		{
			return false;
		}
		
		

		
	}

	public function checkSwipe($story_id,$ip,$card)
	{
		$this->db->where('story_id',$story_id);
		$this->db->where('card_number',$card);
		$this->db->where('ip_address',$ip);
		$check = $this->db->count_all_results("swiper_stats");
		if($check == 0)
		{
			return true;
		}else
		{
			return false;
		}
		
		

		
	}
	public function submitVote($poll,$story_id,$ip)
	{
		$data['option_id'] = $poll ;
		$data['ip_address'] = $ip ;
		$data['story_id'] = $story_id ;
		$this->db->insert('poll_options', $data);
		return $this->db->insert_id();			
		

		
	}	
	public function submitLockEntry($story_id,$ip)
	{
		$data['status'] = 1;
		$data['ip_address'] = $ip ;
		$data['story_id'] = $story_id ;
		$this->db->insert('content_locking', $data);
		return $this->db->insert_id();			
		

		
	}	
	public function submitLeadEntry($story_id,$ip,$email)
	{
		$data['ip_address'] = $ip ;
		$data['story_id'] = $story_id ;
		$data['email'] = $email ;
		$this->db->insert('locking_leads', $data);
		return $this->db->insert_id();			
		

		
	}
	public function submitSwipe($index,$story_id,$ip,$poll)
	{
		$data['card_number'] = $index ;
		$data['ip_address'] = $ip ;
		$data['story_id'] = $story_id ;
		$data['status'] = $poll ;
		$this->db->insert('swiper_stats', $data);
		return $this->db->insert_id();			
		

		
	}
	public function submitAnalytics($ip,$social,$story_id,$timespent,$data)
	{
		$data['ip_address'] = $ip ;
		$data['social_impressions'] = $social ;
		$data['story_id'] = $story_id ;
		$data['raw_data'] = serialize($data) ;
		$data['timespent'] = $timespent ;
		$data['date'] = time() ;
		$this->db->insert('analytics', $data);
		return $this->db->insert_id();			
		

		
	}
	public function CalculateVotes($id,$story_id)
	{
		$this->db->where('story_id',$story_id);
		$this->db->where('option_id',$id);
		return $this->db->count_all_results("poll_options");		
	}
	public function CalculateSwipeVotes($id,$story_id)
	{
		$this->db->where('story_id',$story_id);
		$this->db->where('card_number',$id);
		$this->db->where('status',1);
		return $this->db->count_all_results("swiper_stats");		
	}
	public function totalVotes($story_id)
	{
		$this->db->where('story_id',$story_id);
		return $this->db->count_all_results("poll_options");		
	}
		public function updateToken($token)

    {

        $user = $this->ion_auth->user()->row();

        $userID = $user->id;        

       $data = array(

                'fbuser_access_token' => $token

          );

       

       $this->db->where('id', $userID);

       $this->db->update('users', $data);        

    }
		public function deletePages()
    {
        $u = $this->ion_auth->user()->row();
        $user_id = $u->id;        
        $this->db->where('user_id', $user_id);
       $this->db->delete('fb_settings');        
    }
			public function insertPageDetail($pageid , $pagename , $accesstoken)
	{
		
		$u = $this->ion_auth->user()->row();
		$user_id = $u->id;		
		
		$data['page_name']=$pagename;
		$data['page_id']=$pageid;
		$data['page_access_token']=$accesstoken;
		$data['user_id']=$user_id;
		$this->db->insert('fb_settings', $data);
		
	}
	
	public function getTrackingCodeSnippet($id)
	{
	$this->db->from('stories');
	$this->db->where('story_id',$id);
	$query=$this->db->get();
	
	if ($query->num_rows() > 0) {
	
	$code = '';
	foreach ($query->result() as $row) {
	$data = array();
	$data['siteData']=$row;
	$code=$this->getTrackingCodeId($row->user_id);
	}
	return $code;
	}
	return '';		
		
	}
	public function getUserID($site)
	{
		$this->db->from('users');
		$this->db->where('subdomain',$site);
		$query=$this->db->get();
		$userid = '';
		
		if ($query->num_rows() > 0) {
		
		foreach ($query->result() as $row) {
		$userid=$row->id;
		}
		return $userid;
		}
		return $userid;			
	}
	
	public function getUserStories($userid,$start = 0,$storyid = '')
	{
			$limit = 6;
			//$start = 0;
			$this->db->from('stories');
			
			$this->db->where('user_id', $userid);
			if($storyid !== '')
			{
			$this->db->where('story_id <>', $storyid);
				
			}
			$this->db->limit($limit,$start*$limit);
			$this->db->order_by("story_id", "desc");

			$query = $this->db->get();
			if ($query->num_rows() > 0) {
			$allSites = array();
			foreach ($query->result() as $row) {
			$data = array();
			$data['siteData']=$row;
			$allSites[]=$data;
			}

			return $allSites;
		}
		return false;			
		
	}	
	public function getUserStoriesKeyword($userid,$start = 0,$storyid = '',$keyword)
	{
			$limit = 6;
			//$start = 0;
			$this->db->from('stories');
			
			$this->db->where('user_id', $userid);
			$this->db->where('title like', '%'.$keyword.'%');
			if($storyid !== '')
			{
			$this->db->where('story_id <>', $storyid);
				
			}
			//$this->db->limit($limit,$start*$limit);

			$query = $this->db->get();
			if ($query->num_rows() > 0) {
			$allSites = array();
			foreach ($query->result() as $row) {
			$data = array();
			$data['siteData']=$row;
			$allSites[]=$data;
			}

			return $allSites;
		}
		return false;			
		
	}
	public function getBannerSettings(){		
		$user = $this->ion_auth->user()->row();
		$userID = $user->id;  
		$this->db->from('ad_banner');
		$this->db->where('user_id',$userID);
		$query=$this->db->get();
		
		if ($query->num_rows() > 0) {
		
		$allSites = array();
		foreach ($query->result() as $row) {
		$data = array();
		$data['siteData']=$row;
		$allSites[]=$data;
		}

		return $allSites;
		}
		return false;
	}
	public function getSingleBannerSettings($site_id){		
		$data=array(
			"story_id" => $site_id
		);
		$this->db->from('ad_banner');
		$this->db->where($data);
		$query=$this->db->get();
		
		if ($query->num_rows() > 0) {
		
		$allSites = array();
		foreach ($query->result() as $row) {
		$data = array();
		$data['siteData']=$row;
		$allSites[]=$data;
		}

		return $allSites;
		}
		return false;
	}
	public function getStoryId(){
		$user = $this->ion_auth->user()->row();
		$userID = $user->id; 
		$this->db->select("story_id");
		$this->db->from("stories");
		$this->db->where('user_id',$userID);
		$res=$this->db->get();
		// print_r($res->result());
		if($res->num_rows() > 0)
		{
			$newArr=array();
			foreach ($res->result() as $row) {	
				$newArr[]=$row;
			}
			return $newArr;
		}
	}
	public function getStoryName($storyId){
		$this->db->select("title");
		$this->db->from("stories");
		$this->db->where('story_id',$storyId);
		$res=$this->db->get();
		if($res->num_rows() > 0)
		{
			$newArr=array();
			foreach ($res->result() as $row) {	
				$newArr[]=$row;
			}
			return $newArr;
		}
	}
	public function getSiteBannerData($storyId){
		$this->db->select("*");
		$this->db->from("ad_banner");
		$this->db->where('story_id',$storyId);
		$res=$this->db->get();
		if($res->num_rows() > 0)
		{
			$newArr=array();
			foreach ($res->result() as $row) {	
				$newArr[]=$row;
			}
			return $newArr;
		}
	}
	public function disconnectFb(){
		$u = $this->ion_auth->user()->row();
		$user_id = $u->id;		
		$fbdata=array(
			"fbuser_access_token" => ""
		);
		//print_r($formdata);exit;
		$this->db->where('id', $user_id);
		$this->db->update('users', $fbdata);
		return "success";
	}
	public function getFbStatus(){
		$u = $this->ion_auth->user()->row();
		$user_id = $u->id;	
		$this->db->select("fbuser_access_token");
		$this->db->where('id', $user_id);
		$this->db->from('users');
		$res = $this->db->get();
		$status = $res->result();
		// print_r($status);
		if(!empty($status[0]->fbuser_access_token))
		{
			return $status[0]->fbuser_access_token;
		}
		else{
			return "";
		}
	}


	public function fetchQuotes($keyword)
    {
      $this->db->select("quotes");
      $this->db->where("quotes like '%$keyword%'");
      $this->db->order_by("id", "DESC");
      $this->db->from("quotes");
      $query = $this->db->get();
      if ($query->num_rows() > 0) {
            $keyData = array();
            foreach ($query->result() as $row) {
                //print_r($query->result());
            $data = array();
            $data['quotes']=$row;
            $keyData[]=$data;
                //print_r($allSites);
            }
            return $keyData;
            }
            return false;
    }


    public function checkCategory($cat_name)
    {
    	$user = $this->ion_auth->user()->row();
     	$userID = $user->id;
     	$parent_user_id = $user->parent_user_id;

		if($parent_user_id!=1)
		{
			$userID = $parent_user_id;
		}
     	$this->db->where("user_id",$userID);
     	$this->db->where("name",$cat_name);
     	$this->db->from("categories");
     	$query = $this->db->get();

     	return $query->num_rows();
    }


    public function insertCategory($cat_name,$story_id,$parentCategory)
    {
    	$user = $this->ion_auth->user()->row();
     	$userID = $user->id;
    	
     	$parent_user_id = $user->parent_user_id;

		if($parent_user_id!=1)
		{
			$userID = $parent_user_id;
		}

    	$data = array(
    		'user_id' => $userID,
    		'name' => $cat_name,
    	);
    	if(!empty($parentCategory) || $parentCategory != 0)
    	{
    		// echo "string";
    		$data['parent_category_id'] = $parentCategory;
    	}

    	$this->db->insert("categories",$data);
    	
    }

    public function fetchAllCategories($flag = null)
    {
    	$user = $this->ion_auth->user()->row();
     	$userID = $user->id;


     	$parent_user_id = $user->parent_user_id;

		if($parent_user_id!=1)
		{
			$userID = $parent_user_id;
		}

     	if(isset($flag) && !empty($flag))
     	{
     		$this->db->where("parent_category_id",0);
     	}

     	$this->db->where("user_id",$userID);

     	$this->db->order_by("created_date", "DESC");
		$this->db->from("categories");
		$query = $this->db->get();
		if ($query->num_rows() > 0) {
		    $categoriesData = array();
		    foreach ($query->result() as $row) {
		        //print_r($query->result());
		    $data = array();
		    $data['category']=$row;
		    $categoriesData[]=$data;
		        //print_r($allSites);
		    }
		   	return $categoriesData;
		}
		return false;
    }

    public function fetchSubcategories($cat_id)
    {

    	$user = $this->ion_auth->user()->row();
     	$userID = $user->id;

     	$this->db->where("parent_category_id",$cat_id);
		$this->db->from("categories");
     	$this->db->where("user_id",$userID);

		$query = $this->db->get();
		if ($query->num_rows() > 0) {
		    $categoriesData = array();
		    foreach ($query->result() as $row) {
		        //print_r($query->result());
		    $data = array();
		    $data['subcat']=$row;
		    $categoriesData[]=$data;
		        //print_r($allSites);
		    }
		   	return $categoriesData;
		}
		return false;
    }

    public function fetchStoryCategory($story_id)
    {
    	$this->db->select("categories");
    	$this->db->where("story_id",$story_id);
    	$this->db->from("stories");
    	$query = $this->db->get();

    	return $query->result();
    }


    public function fetchAllSubdomain($clients)
    {

    	// print_r($clients);exit;
    	$user = $this->ion_auth->user()->row();
     	$userID = $user->id;


     	


     	if($userID!=1)
     	{
     		if (strpos($this->session->userdata('access'), '3')==true) {
				// echo "string";exit;
	     		if (!empty($clients)) {
	     			array_push($clients,$userID);
					$this->db->where_in('user_id', $clients);
	     		}
	     		else
	     		{
	     			$this->db->where("user_id",$userID);
					

	     		}
	     	}
	     	else
	     	{
	     		$this->db->where("user_id",$userID);
	     	}
     		
		}

		// exit;
		$this->db->order_by("created_date", "desc");
	
     	$this->db->from("subdomains");

     
     	$query = $this->db->get();
		if ($query->num_rows() > 0) {
		    $categoriesData = array();
		    foreach ($query->result() as $row) {
		        //print_r($query->result());
		    $data = array();
		    $data['subdomain']=$row;
		    $categoriesData[]=$data;
		        //print_r($allSites);
		    }
		   	return $categoriesData;
		}
		return false;

    }


    public function checkSubdomain($subdomain_id)
    {
    	$user = $this->ion_auth->user()->row();
     	$userID = $user->id;

     	$this->db->where("user_id",$userID);
     	$this->db->where("id",$subdomain_id);
     	$this->db->from("subdomains");
     	$query = $this->db->get();
		return $query->num_rows();
    }

    public function getSubdomainName($subdomain_id)
    {
    	// echo $subdomain_id;exit;
    	$this->db->select("subdomain_name");
    	$this->db->where("id",$subdomain_id);
    	$this->db->from("subdomains");
    	$query = $this->db->get();
		return $query->result()[0]->subdomain_name;
    }


    // update the action of hot,trending

    public function updateActions($story_id,$param)
    {
    	$this->db->where("story_id",$story_id);
    	$this->db->update("stories",$param);
    }

	public function check_validate($sec){
		$query=$this->db->query("SELECT * FROM `users` WHERE `landing_page_id` = '$sec'");
		if ($query->num_rows() > 0) {
			return $query->result()[0]->id;
		}else{
			return 0;
		}
	}

	public function fetchPolicyTerms($subdomain_id)
	{
		$user = $this->ion_auth->user()->row();
     	$userID = $user->id;

     	$this->db->where("user_id",$userID);
     	$this->db->where("subdomain_id",$subdomain_id);
     	$this->db->from("termspolicy");
     	$query = $this->db->get();

     	if($query->num_rows()>0)
     	{
     		return $query->result()[0];
     	}
     	else
     	{
     		return false;
     	}


	}
	
	public function update_cnameurl($cname_url,$subdomain_id){
		$data['cname_url']=$cname_url;
		$this->db->where("id",$subdomain_id);
    	$this->db->update("subdomains",$data);
	}

	 public function getCnameUrl($subdomain_id)
    {
    	// echo $subdomain_id;exit;
    	$this->db->select("cname_url");
    	$this->db->where("id",$subdomain_id);
    	$this->db->from("subdomains");
    	$query = $this->db->get();
		return $query->result()[0]->cname_url;
    }


    public function fetchCLients()
    {
    	$user = $this->ion_auth->user()->row();
     	$userID = $user->id;

     	if ($userID!=1) {
     		$this->db->select("id");
    		$this->db->where("parent_user_id",$userID);
    		$this->db->from("users");

    		$query = $this->db->get();
			if ($query->num_rows() > 0) {
			    $categoriesData = array();
			    foreach ($query->result() as $row) {
			        //print_r($query->result());
			    $data = array();
			    $data['users']=$row;
			    $categoriesData[]=$data;
			        //print_r($allSites);
			    }
			   	return $categoriesData;
			}
			return false;

     	}
     	else{
     		return false;
     	}
    }


    public function fetchsubdomainCount()
    {
    	$user = $this->ion_auth->user()->row();
     	$userID = $user->id;

     	if($userID!=1)
     	{
     		$this->db->where("user_id",$userID);
     		$this->db->from("subdomains");
     		$query = $this->db->get();

     		return $query->num_rows();
     	}
    }


    public function fetchTotalCampaignbyUsers()
    {
    	$user = $this->ion_auth->user()->row();
     	$userID = $user->id;

     	if($userID!=1)
     	{
     		$this->db->where("user_id",$userID);
     		$this->db->from("stories");
     		$query = $this->db->get();

     		return $query->num_rows();
     	}
    }


    public function fetchDfy($where)
    {
    	$user = $this->ion_auth->user()->row();
     	$userID = $user->id;
		$todd_user_arr=array(316,313,305,237,193,184,160,143,135,124);

        if(in_array($userID,$todd_user_arr)){
			// $this->db->where("dfy",33);
			array_push($where, 33);
		}
		
    	if(is_array($where))
    	{
    		$this->db->where_in('dfy', $where);
    	}
    	else
    	{
    		$this->db->where("dfy",1);
    	}

    	$this->db->from("stories");
    	$query = $this->db->get();
    	// echo $this->db->last_query();exit;
    	if ($query->num_rows() > 0) {
		    $categoriesData = array();
		    foreach ($query->result() as $row) {
		        //print_r($query->result());
		    $data = array();
		    $data['dfy']=$row;
		    $categoriesData[]=$data;
		        //print_r($allSites);
		    }
		   	return $categoriesData;
		}
			return false;
    }


    public function fetchMysubdomain()
    {

    	$user = $this->ion_auth->user()->row();
     	$userID = $user->id;

     	$this->db->where("user_id",$userID);
    	$this->db->order_by("created_date", "desc");
	
     	$this->db->from("subdomains");

     
     	$query = $this->db->get();
		if ($query->num_rows() > 0) {
		    $categoriesData = array();
		    foreach ($query->result() as $row) {
		        //print_r($query->result());
		    $data = array();
		    $data['mysubdomain']=$row;
		    $categoriesData[]=$data;
		        //print_r($allSites);
		    }
		   	return $categoriesData;
		}
		return false;
    }

    public function fetchSubdomainsClientsDfy($subdomain_ids)
    {
    	$user = $this->ion_auth->user()->row();
     	$userID = $user->id;

     	$this->db->where_in("id",$subdomain_ids);
    	$this->db->order_by("created_date", "desc");
	
     	$this->db->from("subdomains");

     
     	$query = $this->db->get();
		if ($query->num_rows() > 0) {
		    $categoriesData = array();
		    foreach ($query->result() as $row) {
		        //print_r($query->result());
		    $data = array();
		    $data['mysubdomain']=$row;
		    $categoriesData[]=$data;
		        //print_r($allSites);
		    }
		   	return $categoriesData;
		}
		return false;
    }


    public function cloneinsertCampaign($title,$description,$image,$totalBlocks,$content,$tags,$subdomain_id,$type)
	{
		$u = $this->ion_auth->user()->row();
		$user_id = $u->id;		
		$data['title'] = $title ;
		$data['description'] = $description ;
		$data['image'] = $image ;
		$data['items_loaded'] = $totalBlocks ;
		$data['draf_content'] =  $content ;
		$data['content'] = $content;
		$data['date_created'] =  time() ;
		$data['user_id'] = $user_id;
		$data['tags'] = $tags;
		$data['subdomain_id'] = $subdomain_id;
		$data['type'] = $type;
		$this->db->insert('stories', $data);
		return $this->db->insert_id();		
		
	}


	public function fetchUsersassignDomain($cleint_user_id)
	{

    	$user = $this->ion_auth->user()->row();
     	$userID = $user->id;

     	$this->db->where("parent_user_id",$userID);
     	$this->db->where("user_id",$cleint_user_id);
    	
	
     	$this->db->from("clientsubdomain");

     
     	$query = $this->db->get();
		if ($query->num_rows() > 0) {
		    $categoriesData = array();
		    foreach ($query->result() as $row) {
		        //print_r($query->result());
		    $data = array();
		    $data['assignsubdomain']=$row;
		    $categoriesData[]=$data;
		        //print_r($allSites);
		    }
		   	return $categoriesData;
		}
		return false;
	}

	public function fetchUsersassignDomains($cleint_user_id)
	{

    	$user = $this->ion_auth->user()->row();
     	$userID = $user->id;

     
     	$this->db->where("user_id",$cleint_user_id);
    	
	
     	$this->db->from("clientsubdomain");

     
     	$query = $this->db->get();
		if ($query->num_rows() > 0) {
		    $categoriesData = array();
		    foreach ($query->result() as $row) {
		        //print_r($query->result());
		    $data = array();
		    $data['assignsubdomain']=$row;
		    $categoriesData[]=$data;
		        //print_r($allSites);
		    }
		   	return $categoriesData;
		}
		return false;
	}


	public function deleteAssignSubdomain($cleint_user_id)
	{
		$this->db->where("user_id",$cleint_user_id);
		$this->db->delete("clientsubdomain");
	}



	public function insertClientSubdoamin($sub_id,$cleint_user_id)
	{
		$user = $this->ion_auth->user()->row();
     	$userID = $user->id;

     	$data['parent_user_id'] = $userID;
     	$data['subdomain_id'] = $sub_id;
     	$data['user_id'] = $cleint_user_id;

     	$this->db->insert("clientsubdomain",$data);
	}



	public function fetchSubdomainsClients($subdomain_ids)
	{
		if(!empty($subdomain_ids))
		{
			$this->db->from("subdomains");

	   

		    $this->db->where_in('id', $subdomain_ids);
		     		
			
			$this->db->order_by("created_date", "desc");
		

			$query = $this->db->get();
			if ($query->num_rows() > 0) {
				$allSites = array();
				foreach ($query->result() as $row) {
					$data = array();
					$data['siteData']=$row;
					$allSites[]=$data;
				}
				return $allSites;
			}
			return false;	
		}
		else
		{
			return false;
		}
	}


	public function fetchSubdomainsClientsHeaders($subdomain_ids)
	{
		if(!empty($subdomain_ids))
		{
			$this->db->from("subdomains");

	   

		    $this->db->where_in('id', $subdomain_ids);
		     		
			
			$this->db->order_by("created_date", "desc");
		

			$query = $this->db->get();
			if ($query->num_rows() > 0) {
				$allSites = array();
				foreach ($query->result() as $row) {
					$data = array();
					$data['subdomain']=$row;
					$allSites[]=$data;
				}
				return $allSites;
			}
			return false;	
		}
		else
		{
			return false;
		}
	}

	public function exportCsv($name,$camp_id,$type){
            $this->load->dbutil();
            $this->load->helper('file');
            $this->load->helper('download');
            $delimiter = ",";
            $newline = "\r\n";
            $filename = $name.".csv";
            $query = "SELECT name,email,subscribe_date FROM subscribe where camp_id=$camp_id and type = '$type'"; //USE HERE YOUR QUERY
            $result = $this->db->query($query);
            // print_r($result);
            // exit;
            $data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
            force_download($filename, $data);
    }

    public function aggreform()
    {
    	$user = $this->ion_auth->user()->row();
     	$userID = $user->id;

     	$data['policy'] = 1;
     	$this->db->where("id",$userID);
     	$this->db->update("users",$data);
    }

    //Manage subdomain requests
    public function getDeleteSubdomainCount($status = ''){
    	if(!empty($status)){
    		if($status == "pending"){
    			$status = 0;
    		}else{
				$status = 1;
    		}
    		$this->db->where('status',$status);
    	}
    	$this->db->select("*");
    	$this->db->from("trash_subdomain");
    	$res = $this->db->get();
    	return $num_rows = $res->num_rows();
    }
    
    public function listDeleteSubdomainData($limit='',$start='',$status = ''){

    	if(!empty($status)){
    		
    		if($status == "pending"){
    			$status = 0;
    		}else{
				$status = 1;
    		}
    		$this->db->where('status',$status);
    	}

    	if($limit !== '' && $start !== ''){
            $query= $this->db->limit($limit,$start*$limit);
        }
        $this->db->order_by('status', 'ASC');
    	$this->db->select("*");
    	$this->db->from("trash_subdomain");
    	$res = $this->db->get();
    	$num_rows = $res->num_rows();
    	// exit;
    	$data = $res->result();
    	$tempData = array();
    	foreach ($data as $key => $value) {
    		$arr[$key] = $value;
    		$tempData["subdomain_data"] = $arr;
    	}
    	return $tempData;
    	// return $data;
    }

    public function checkSubdomainDeleteStatus($subdomain_id){
    	$this->db->where("subdomain_id",$subdomain_id);
    	$this->db->select("status");
    	$this->db->from("trash_subdomain");
    	$res = $this->db->get();
    	if($res->num_rows() > 0 ){
    		$status = $res->result()[0]->status;
    		if($status == 0){
    			return "true";
    		}
    	}else{
    		return "false";
    	} 	
    }

    public function restoreSubdomain($subdomain_id){
    	$data = array('subdomain_id' => $subdomain_id);
    	$this->db->delete("trash_subdomain",$data);
    }

	public function requestDeleteSubdomain($subdomain_id,$user_id,$subdomain_url){
	    	$data = array('subdomain_id' => $subdomain_id,'user_id' => $user_id,'url' => $subdomain_url);
	    	$this->db->insert("trash_subdomain",$data);
	}

    public function updateSubdomaindelStatus($subdomain_id){
    	$data = array('subdomain_id' => $subdomain_id);
    	$data1 = array('status' => 1,'proceed_date' => date('Y-m-d H:i:s'));
    	$this->db->where($data);
    	$this->db->set($data1);
    	$this->db->update("trash_subdomain");
    }

    public function deleteStoryData($story_id){
    	//ad baner
    	$this->db->where('story_id', $story_id);
		$this->db->delete('ad_banner');

		//analytics
		$this->db->where('story_id', $story_id);
		$this->db->delete('analytics');
		
		//content_locking
		$this->db->where('story_id', $story_id);
		$this->db->delete('content_locking');

		//locking_leads
		$this->db->where('story_id', $story_id);
		$this->db->delete('locking_leads');
		
		//poll_options
		$this->db->where('story_id', $story_id);
		$this->db->delete('poll_options');

		//poll_results
		$this->db->where('story_id', $story_id);
		$this->db->delete('poll_results');

		//subscribe
		$this->db->where('camp_id', $story_id);
		$this->db->delete('subscribe');

		//swiper_stats
		$this->db->where('story_id', $story_id);
		$this->db->delete('swiper_stats');

		//stories
		$this->db->where('story_id', $story_id);
		$this->db->delete('stories');

    }
    
    public function removeSubdomainData($subdomain_id){
    	$user = $this->ion_auth->user()->row();
     	$userID = $user->id;

    	//from apperaiance
    	$this->db->where('subdomain_id', $subdomain_id);
		$this->db->delete('appearance');

		//autoresponder
		$this->db->where('subdomain_id', $subdomain_id);
		$this->db->delete('autoresponder');

		//delete stories data
		$this->db->select("story_id");
		$this->db->where("subdomain_id",$subdomain_id);
		$this->db->from("stories");
		$res = $this->db->get();
		foreach ($res->result() as $key => $story) {
			$single_story = $story->story_id;
			$this->deleteStoryData($single_story);
		}

		//subscribe
		$this->db->where('domain_id', $subdomain_id);
		$this->db->delete('subscribe');
		

		//clients subdomain
		$this->db->where('subdomain_id', $subdomain_id);
		$this->db->delete('clientsubdomain');

		//subdomains
		$this->db->where('id', $subdomain_id);
		$this->db->delete('subdomains');

		//Preserve removed subdomain entry
		$this->updateSubdomaindelStatus($subdomain_id);
    }

    public function fetchCsustomCss($subdomain_id){
    	$this->db->where("subdomain_id",$subdomain_id);
    	$this->db->select("custom_css");
    	$this->db->from("appearance");
    	$res = $this->db->get();
    	if($res->num_rows() > 0){
    		return $res->result()[0]->custom_css;
    	}
    	// echo "string";
    	
    }
   	public function CountAppearanceRecord($subdomain_id){
   		echo $subdomain_id;
   		$this->db->where("subdomain_id",$subdomain_id);
    	$this->db->select("*");
    	$this->db->from("appearance");
    	$res = $this->db->get();
    	// print_r($res);
    	return $res->num_rows();
   	}

    public function addCustomCss($id,$csstext){
    	echo $count = $this->CountAppearanceRecord($id);
    	if($count > 0 ){
    		$this->db->set("custom_css",$csstext);
	    	$this->db->where("subdomain_id",$id);
	    	$this->db->update("appearance");	
    	}else{
		    $user = $this->ion_auth->user()->row();
	     	$userID = $user->id;

    		$data = array(
    			"user_id" => $userID,
    			"subdomain_id" => $id,
    			"custom_css" => $csstext
    		);
    		$this->db->insert("appearance",$data);
    	}
    	
    }
   
}
