<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class Embeded_model extends CI_Model {
    function __construct()
    {
        parent::__construct();
        $this->load->database();
    }

    public function checkSpinWheelData($camp_id,$email,$ip)
    {
    	$this->db->where("camp_id",$camp_id);
    	$this->db->where("email",$email);
    	$this->db->where("ip_address",$ip);
		$this->db->from("spinwheel");

		$query = $this->db->get();

		return $query->num_rows();
    }

    public function insertSpinWheelrecord($camp_id,$email,$ip,$spintext)
    {
    	$data['camp_id'] = $camp_id;
    	$data['email'] = $email;
    	$data['ip_address'] = $ip;
    	$data['spinText'] = $spintext;
    	$this->db->insert("spinwheel",$data);
    }


	public function getAllViews($id){

		return $this->db->where('story_id ',$id)->count_all_results("analytics");
		
	}
	public function getTotalLeads($id){

		return $this->db->where('story_id ',$id)->count_all_results("locking_leads");
		
	}
	public function getAllSocial($id){

		return $this->db->where('story_id ',$id)->where('social_impressions',1)->count_all_results("analytics");
		
	}
	
	public function getAllUniqueViews($id){

		return $this->db->distinct()->select('ip_address')->where('story_id',$id)->count_all_results("analytics");
		
	}
	public function checkUserType($id){

		$views = $this->db->where('story_id',$id)->where('ip_address',$_SERVER['REMOTE_ADDR'])->count_all_results("content_locking");
		if($views == 0)
		{
			return 'new';
		}else
		{
			return 'returning';
		}
		
	}	
	public function checkUserPoll($id){

		$views = $this->db->where('story_id',$id)->where('ip_address',$_SERVER['REMOTE_ADDR'])->count_all_results("poll_options");
		if($views == 0)
		{
			return 'new';
		}else
		{
			return 'returning';
		}
		
	}	
	public function getAverageTimeSpent($id){

		$query = $this->db->select('AVG(timespent) as timespents')->where('story_id',$id)->get("analytics");
			if ($query->num_rows() > 0) {
			$allSites = array();
			foreach ($query->result() as $row) {
			$data = array();
			$data['siteData']=$row;
			$allSites[]=$data;
			}

			$avgTime = $allSites[0]['siteData']->timespents;
			
			$hours = floor($avgTime / 60);
			$minutes = ((int)$avgTime % 60);
			return $hours.':'.$minutes;
			}
			return false;		
		
	}

	//fetching data from db table
	
	public function getFrameDetail($id) 
	{

		$this->db->from('stories');
		$this->db->where('story_id',$id);
		$query=$this->db->get();
		
		if ($query->num_rows() > 0) {
		
		$allSites = array();
		foreach ($query->result() as $row) {
		$data = array();
		$data['siteData']=$row;
		$allSites[]=$data;
		}

		return $allSites;
		}
		return false;
	}	
		

	public function fetchAllSettingsID($id) {
 
	$this->db->from('appearance');
	$this->db->where('user_id',$id);
	$query=$this->db->get();
	
	if ($query->num_rows() > 0) {
	
	$allSites = array();
	foreach ($query->result() as $row) {
	$data = array();
	$data['siteData']=$row;
	$allSites[]=$data;
	}

	return $allSites;
	}
	return false;
	}	
	
	//fetching data from db table
	
	public function getWpSite($id) {

	$this->db->from('xmlrpc_details');
	$this->db->where('id',$id);
	$query=$this->db->get();
	
	if ($query->num_rows() > 0) {
	
	$allSites = array();
	foreach ($query->result() as $row) {
	$data = array();
	$data['siteData']=$row;
	$allSites[]=$data;
	}

	return $allSites;
	}
	return false;
	}	
	//fetching data from db table
	

	
	public function getAmazonKeysUser($user) {

	$this->db->from('amazon_keys');
	$this->db->where('user_id',$user);
	$query=$this->db->get();
	
	if ($query->num_rows() > 0) {
	
	$allSites = array();
	foreach ($query->result() as $row) {
	$data = array();
	$data['siteData']=$row;
	$allSites[]=$data;
	}

	return $allSites;
	}
	return false;
	}


	//fetching data from db table
	


	public function getTrackingCodeId($user) {
  
	$this->db->from('tracking_codes');
	$this->db->where('user_id',$user);
	$query=$this->db->get();
	
	if ($query->num_rows() > 0) {
	
	$allSites = array();
	foreach ($query->result() as $row) {
	$data = array();
	$data['siteData']=$row;
	$allSites[]=$data;
	}

	return $allSites[0]['siteData']->tracking_code;
	}
	return '';
	}	
	

	
	
	public function checkBannerAppearance($story_id) {
		return $this->db->where('story_id',$story_id)->count_all_results("ad_banner");
		
	}
	
	
	
	
	
	

	public function updateWpSingleSite($id,$username,$password)
	{
	
		$data['username'] = $username;
		$data['password'] = $password;

    	$this->db->where('id', $id);
    	$this->db->update('xmlrpc_details', $data);
	}
	public function deleteStory($id)
	{
		$this->db->where('story_id', $id);

		$this->db->delete('stories');
		
	}
	public function deleteWpSingleSite($id)
	{
		$this->db->where('id', $id);

		$this->db->delete('xmlrpc_details');
		
	}
	
	public function checkVote($story_id,$ip)
	{
		$this->db->where('story_id',$story_id);
		$this->db->where('ip_address',$ip);
		$check = $this->db->count_all_results("poll_options");
		if($check == 0)
		{
			return true;
		}else
		{
			return false;
		}
		
		

		
	}

	public function checkSwipe($story_id,$ip,$card)
	{
		$this->db->where('story_id',$story_id);
		$this->db->where('card_number',$card);
		$this->db->where('ip_address',$ip);
		$check = $this->db->count_all_results("swiper_stats");
		if($check == 0)
		{
			return true;
		}else
		{
			return false;
		}
		
		

		
	}
	public function submitVote($poll,$story_id,$ip)
	{
		$data['option_id'] = $poll ;
		$data['ip_address'] = $ip ;
		$data['story_id'] = $story_id ;
		$this->db->insert('poll_options', $data);
		return $this->db->insert_id();			
		

		
	}	
	public function submitLockEntry($story_id,$ip)
	{
		$data['status'] = 1;
		$data['ip_address'] = $ip ;
		$data['story_id'] = $story_id ;
		$this->db->insert('content_locking', $data);
		return $this->db->insert_id();			
		

		
	}	
	public function submitLeadEntry($story_id,$ip,$email)
	{
		$data['ip_address'] = $ip ;
		$data['story_id'] = $story_id ;
		$data['email'] = $email ;
		$this->db->insert('locking_leads', $data);
		return $this->db->insert_id();			
	}
	public function submitSwipe($index,$story_id,$ip,$poll)
	{
		$data['card_number'] = $index ;
		$data['ip_address'] = $ip ;
		$data['story_id'] = $story_id ;
		$data['status'] = $poll ;
		$this->db->insert('swiper_stats', $data);
		return $this->db->insert_id();			
		

		
	}
	public function submitAnalytics($ip,$social,$story_id,$timespent)
	{
		$data['ip_address'] = $ip ;
		$data['social_impressions'] = $social ;
		$data['story_id'] = $story_id ;
		$data['timespent'] = $timespent ;
		$data['date'] = time() ;
		$this->db->insert('analytics', $data);
		return $this->db->insert_id();			
		

		
	}
	public function CalculateVotes($id,$story_id)
	{
		$this->db->where('story_id',$story_id);
		$this->db->where('option_id',$id);
		return $this->db->count_all_results("poll_options");		
	}
	public function CalculateSwipeVotes($id,$story_id)
	{
		$this->db->where('story_id',$story_id);
		$this->db->where('card_number',$id);
		$this->db->where('status',1);
		return $this->db->count_all_results("swiper_stats");		
	}
	public function totalVotes($story_id)
	{
		$this->db->where('story_id',$story_id);
		return $this->db->count_all_results("poll_options");		
	}
	
		
			
	
	public function getTrackingCodeSnippet($id)
	{
	$this->db->from('stories');
	$this->db->where('story_id',$id);
	$query=$this->db->get();
	
	if ($query->num_rows() > 0) {
	
	$code = '';
	foreach ($query->result() as $row) {
	$data = array();
	$data['siteData']=$row;
	$code=$this->getTrackingCodeId($row->user_id);
	}
	return $code;
	}
	return '';		
		
	}
	public function getUserID($site)
	{
		$this->db->from('users');
		$this->db->where('subdomain',$site);
		$query=$this->db->get();
		$userid = '';
		
		if ($query->num_rows() > 0) {
		
		foreach ($query->result() as $row) {
		$userid=$row->id;
		}
		return $userid;
		}
		return $userid;			
	}
	
	public function getUserStories($subdomain_id,$start = 0)
	{
			$limit = 10;
			//$start = 0;
			$this->db->from('stories');
			
			$this->db->where('subdomain_id', $subdomain_id);
			
			$this->db->limit($limit,$start*$limit);
			$this->db->order_by("story_id", "desc");

			$query = $this->db->get();
			if ($query->num_rows() > 0) {
			$allSites = array();
			foreach ($query->result() as $row) {
			$data = array();
			$data['siteData']=$row;
			$allSites[]=$data;
			}

			return $allSites;
		}
		return false;			
		
	}	

	public function getUserTopicStories($subdomain_id ,$start=0,$topic_name='')
	{

		$limit = 10;
		//$start = 0;
		$this->db->from('stories');
		
		$this->db->where('subdomain_id', $subdomain_id);
		if(!empty($topic_name) && $topic_name!='latest')
		{
			$this->db->where($topic_name,1);
		}
		$this->db->limit($limit,$start*$limit);
		$this->db->order_by("date_created", "desc");

		$query = $this->db->get();
		if ($query->num_rows() > 0) {
			$allSites = array();
			foreach ($query->result() as $row) {
			$data = array();
			$data['siteData']=$row;
			$allSites[]=$data;
			}

			return $allSites;
		}
		return false;
	}


	public function getUserCatStories($subdomain_id ,$start=0,$cat_id)
	{


		$limit = 10;
		//$start = 0;
		$this->db->from('stories');
		
		$this->db->where('subdomain_id', $subdomain_id);
		$this->db->where("categories Like '%".$cat_id."%'");
		$this->db->limit($limit,$start*$limit);
		$this->db->order_by("date_created", "desc");

		$query = $this->db->get();
		if ($query->num_rows() > 0) {
			$allSites = array();
			foreach ($query->result() as $row) {
			$data = array();
			$data['siteData']=$row;
			$allSites[]=$data;
			}

			return $allSites;
		}
		return false;
	}


	

	public function getUserTypetories($subdomain_id ,$start=0,$type)
	{


		$limit = 10;
		//$start = 0;
		$this->db->from('stories');
		
		$this->db->where('subdomain_id', $subdomain_id);
		$this->db->where("type Like",$type);
		$this->db->limit($limit,$start*$limit);
		$this->db->order_by("date_created", "desc");

		$query = $this->db->get();
		if ($query->num_rows() > 0) {
			$allSites = array();
			foreach ($query->result() as $row) {
			$data = array();
			$data['siteData']=$row;
			$allSites[]=$data;
			}

			return $allSites;
		}
		return false;
	}

	public function getUserSearchStories($subdomain_id ,$start=0,$q)
	{



		$limit = 10;
		//$start = 0;
		$this->db->from('stories');
		
		$this->db->where('subdomain_id', $subdomain_id);
		$this->db->where('title like', '%'.$keyword.'%');
		$this->db->limit($limit,$start*$limit);
		$this->db->order_by("date_created", "desc");

		$query = $this->db->get();
		if ($query->num_rows() > 0) {
			$allSites = array();
			foreach ($query->result() as $row) {
			$data = array();
			$data['siteData']=$row;
			$allSites[]=$data;
			}

			return $allSites;
		}
		return false;
	}

	public function fetchUsername($user_id)
	{
		$this->db->where("id",$user_id);
		$this->db->select("first_name,last_name");
		$this->db->from("users");
		$query = $this->db->get();

		return $query->result()[0]->first_name;
	}

	public function getUserStoriesKeyword($userid,$start = 0,$storyid = '',$keyword)
	{
			$limit = 6;
			//$start = 0;
			$this->db->from('stories');
			
			$this->db->where('user_id', $userid);
			$this->db->where('title like', '%'.$keyword.'%');
			if($storyid !== '')
			{
			$this->db->where('story_id <>', $storyid);
				
			}
			//$this->db->limit($limit,$start*$limit);

			$query = $this->db->get();
			if ($query->num_rows() > 0) {
			$allSites = array();
			foreach ($query->result() as $row) {
			$data = array();
			$data['siteData']=$row;
			$allSites[]=$data;
			}

			return $allSites;
		}
		return false;			
		
	}

	public function getSingleBannerSettings($site_id){		
		$data=array(
			"story_id" => $site_id
		);
		$this->db->from('ad_banner');
		$this->db->where($data);
		$query=$this->db->get();
		
		if ($query->num_rows() > 0) {
		
		$allSites = array();
		foreach ($query->result() as $row) {
		$data = array();
		$data['siteData']=$row;
		$allSites[]=$data;
		}

		return $allSites;
		}
		return false;
	}

	public function getStoryName($storyId){
		$this->db->select("title");
		$this->db->from("stories");
		$this->db->where('story_id',$storyId);
		$res=$this->db->get();
		if($res->num_rows() > 0)
		{
			$newArr=array();
			foreach ($res->result() as $row) {	
				$newArr[]=$row;
			}
			return $newArr;
		}
	}
	public function getSiteBannerData($storyId){
		$this->db->select("*");
		$this->db->from("ad_banner");
		$this->db->where('story_id',$storyId);
		$res=$this->db->get();
		if($res->num_rows() > 0)
		{
			$newArr=array();
			foreach ($res->result() as $row) {	
				$newArr[]=$row;
			}
			return $newArr;
		}
	}
	
	


	public function fetchQuotes($keyword)
    {
      $this->db->select("quotes");
      $this->db->where("quotes like '%$keyword%'");
      $this->db->order_by("id", "DESC");
      $this->db->from("quotes");
      $query = $this->db->get();
      if ($query->num_rows() > 0) {
            $keyData = array();
            foreach ($query->result() as $row) {
                //print_r($query->result());
            $data = array();
            $data['quotes']=$row;
            $keyData[]=$data;
                //print_r($allSites);
            }
            return $keyData;
            }
            return false;
    }
	public function check_validate($sec){
		//echo "SELECT * FROM `users` WHERE `landing_page_id` = '$sec'";
		$query=$this->db->query("SELECT * FROM `users` WHERE `landing_page_id` = '$sec'");
		if ($query->num_rows() > 0) {
			return $query->result()[0]->id;
		}else{
			return 0;
		}
		//
		//print_r($query->result());

	}
	public function get_wp_install_count($check){
		//echo "SELECT * FROM `users` WHERE `landing_page_id` = '$sec'";
		$query=$this->db->query("SELECT * FROM `xmlrpc_details` WHERE `user_id` = '$check'");
		return $query->num_rows();
		//
		//print_r($query->result());

	}
	public function getall_userpages($id){
		
		$res=$this->db->select('stories.story_id,stories.subdomain_id,stories.title,stories.date_created,stories.tags,subdomains.subdomain_name')->from('stories')->join('subdomains','stories.subdomain_id = subdomains.id')->where('stories.user_id',$id)->get();
		//echo $this->db->last_query();
		$newArr=array();
		if($res->num_rows() > 0)
		{
			
			foreach ($res->result() as $row) {	
				$newArr[]=$row;
			}
			$newArr['no_of_pages']=$res->num_rows();
			return $newArr;
		}else{
			$newArr['no_of_pages']=0;
			return $newArr; 

		}
		
	}
	public function add_wp_activate_url($id,$url){
		$url=unserialize($url);
		$data['user_id'] = $id ;
		$data['url'] = $url;
		$query=$this->db->query("SELECT * FROM `xmlrpc_details` WHERE `user_id` = '$id' and `url`='$url'");
		//echo $this->db->last_query();exit;
		if ($query->num_rows() > 0) {
			$this->db->where('user_id', $id);
			$this->db->update('xmlrpc_details', $data);
		}else{
			$this->db->insert('xmlrpc_details', $data);
		}
		
	}
	public function get_user_access($check){
		$query=$this->db->query("SELECT access FROM `users` WHERE `id` = '$check'");
		if ($query->num_rows() > 0) {
			return $query->result()[0]->access;
		}else{
			return 0;
		}
	}
	public function get_user_parent_id($id){
		$query=$this->db->query("SELECT parent_user_id FROM `users` WHERE `id` = '$id'");
		if ($query->num_rows() > 0) {
			return $query->result()[0]->parent_user_id;
		}else{
			return 0;
		}
	}

	//subscribe form

    public function checkSubscribtionByDomain($domain_id,$email,$ip)
    {
    	$this->db->where("domain_id",$domain_id);
    	$this->db->where("email",$email);
    	$this->db->where("ip_address",$ip);
		$this->db->from("subscribe");

		$query = $this->db->get();

		return $query->num_rows();
    }

   public function checkSubscribtionByStory($camp_id,$email,$ip)
   {
    	$this->db->where("camp_id",$camp_id);
    	$this->db->where("email",$email);
    	$this->db->where("ip_address",$ip);
		$this->db->from("subscribe");

		$query = $this->db->get();

		return $query->num_rows();
    }

    public function checkSubscribtionByType($camp_id,$email,$ip,$type)
    {
    	$this->db->where("camp_id",$camp_id);
    	$this->db->where("email",$email);
    	$this->db->where("ip_address",$ip);
    	$this->db->where("type",$type);
		$this->db->from("subscribe");

		$query = $this->db->get();

		return $query->num_rows();
    }

    public function insertSubscribeRecord($camp_id,$domain_id,$email,$name,$contact,$ip,$type)
    {
    	$data['domain_id'] = $domain_id;
    	$data['camp_id'] = $camp_id;
    	$data['email'] = $email;
    	$data['name'] = $name;
    	$data['contact'] = $contact;
    	$data['ip_address'] = $ip;
    	$data['type'] = $type;
   
    	$this->db->insert("subscribe",$data);
    }
}