<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class Embeded_model extends CI_Model {
    function __construct()
    {
        parent::__construct();
        $this->load->database();
    }

    public function fetchUserId($subdomain_id){
        $this->db->where("id",$subdomain_id);
        $this->db->select("user_id");
        $this->db->from("subdomains");
        $res = $this->db->get();
        if($res->num_rows() > 0){
            return  $res->result()[0]->user_id;
        }else{
            return false;
        }
    }
    public function getSubdomainIdFromUid($subdomain_uid){
        $data = array(
            "subdomain_uid" => $subdomain_uid,
        );
        $this->db->where($data);
        $this->db->select("id");
        $this->db->from("subdomains");
        $res = $this->db->get();
        if($res->num_rows() > 0){
            return  $res->result()[0]->id;
        }else{
            return false;
        }
    }

    public function getTemplate($subdomain_id){
        $data = array(
            "id" => $subdomain_id,
        );
        $this->db->where($data);
        $this->db->select("template");
        $this->db->from("subdomains");
        $res = $this->db->get();
        if($res->num_rows() > 0){
            return  $res->result()[0]->template;
        }
    }


    public function checkTemplate($site_uid){
        $this->db->where("site_uid",$site_uid);
        $this->db->select("status");
        $this->db->from("websites");
        $res = $this->db->get();
        if($res->num_rows() > 0){
            $e = $res->result()[0]->status;
        }
        return $e;
    }

    public function getSiteUid($temp_id,$subdomain_id){
        $data = array(
            "temp_id" => $temp_id,
            "subdomain_id" => $subdomain_id
        );  
        $this->db->where($data);
        $this->db->select("site_uid");
        $this->db->from("websites");
        $res = $this->db->get();
        if($res->num_rows() > 0){
            $e = $res->result()[0]->site_uid;
        }else{
            $e = "Site not availiable";
        }
        return $e;
    }

    public function fetchAllSettings($subdomain_id) {
        $this->db->from('appearance');
        $this->db->where("subdomain_id",$subdomain_id);
        $query=$this->db->get();
        if ($query->num_rows() > 0) {
            $allSites = array();
            foreach ($query->result() as $row) {
            $data = array();
            $data['siteData']=$row;
            $allSites[]=$data;
        }
            return $allSites;
        }

        return false;
    }

    public function fetchAutoresponder($subdomain_id,$mainType)
    {
        $this->db->from('autoresponder');
        $this->db->where("respondertype",$mainType);
        $this->db->where("subdomain_id",$subdomain_id);
        $query=$this->db->get();
        if ($query->num_rows() > 0) {
        
            return $query->result()[0]; 
        }
        return false;
    }

    public function getWebPage($subdomain_uid,$page){
        // echo $page;
        $data = array(
            "site_uid" => $subdomain_uid,
        );
        if($page == "home" || $page == "Home"){
            $page_name = "home_content";    
        }
        else if($page == "contact" || $page == "Contact"){
            $page_name = "contact_content"; 
        }
        else if($page == "team" || $page == "Team"){
            $page_name = "team_content";    
        }
        else if($page == "services" || $page == "Services"){
            $page_name = "services_content";    
        }
        else if($page == "blog" || $page == "Blog"){
            $page_name = "blog_content";    
        }else{
            return "error";
        }

        $this->db->where($data);
        $this->db->select($page_name);
        $this->db->from("websites");
        $res = $this->db->get();
        if($res->num_rows() > 0){
            $e = $res->result()[0];
        }else{
            $e = "Site not availiable";
        }
        return $e;
    }

    //subscribe form
    public function checkSubscribtionByType($camp_id,$email,$ip,$type)
    {
        $this->db->where("camp_id",$camp_id);
        $this->db->where("email",$email);
        $this->db->where("ip_address",$ip);
        $this->db->where("type",$type);
        $this->db->from("subscribe");

        $query = $this->db->get();

        return $query->num_rows();
    }

    public function insertSubscribeRecord($camp_id,$domain_id,$email,$name,$contact,$ip,$type)
    {
        $data['domain_id'] = $domain_id;
        $data['camp_id'] = $camp_id;
        $data['email'] = $email;
        $data['name'] = $name;
        $data['contact'] = $contact;
        $data['ip_address'] = $ip;
        $data['type'] = $type;
   
        $this->db->insert("subscribe",$data);
    }

    public function getPageCount($id)
 	{
         //echo $id; exit;
 		$cols=array("subdomain_uid" => $id);
 		$this->db->select("visits")->from("subdomains")->where($cols);
 		$res=$this->db->get();
 		$db_data=$res->result();
 		$newArr=array();
 		foreach($db_data as $key => $value)
 		{
 			$newArr["getCount"]=$value;
 		}
 		return $newArr;
 	}

    public function submitAnalytics($ip,$social,$site_uid,$timespent)
    {
        $data['ip_address'] = $ip ;
        $data['social_impressions'] = $social ;
        $data['story_id'] = $site_uid ;
        //$data['raw_data'] = serialize($data) ;
        $data['timespent'] = $timespent ;
        $data['date'] = time();
        $this->db->insert('analytics', $data);
        return $this->db->insert_id();
    }

     public function updatePageCount($id,$count)
 	{
 		$cols1=array("subdomain_uid"=>$id);
 		$cols2=array("visits"=>$count);
 		$this->db->set($cols2)->where($cols1)->update("subdomains");
 	}
}