<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class Subdomain_model extends CI_Model {
    function __construct()
    {
        parent::__construct();
        $this->load->database();
        $this->load->config('subdomain_config');

    }

	public function record_website_count($subdomain_id = null)
	{	
		$user = $this->ion_auth->user()->row();
		$userID = $user->id;

		if(!empty($subdomain_id))
		{
			$this->db->where("websites.subdomain_id",$subdomain_id);
		}
		// $this->db->where("websites.status",1);
		if($userID != 1)
			$this->db->where("user_id",$userID);
		
		return $this->db->join('users', 'subdomains.user_id = users.id')->count_all_results("subdomains");
		
	}

	
	/*
	
		fetching all subdomains of particular users
	
	*/
    public function fetchSubdomains($user_id,$clients, $limit = '', $start = '')
    {
    	// print_r($this->session->userdata('access'));exit;
    	// $this->db->where('user_id ',$user_id );
    	$this->db->from("subdomains");

		if ($limit !== '' && $start !== ''){
			$this->db->limit($limit,$start*$limit);
		   }

    	if($user_id!=1)
     	{
     		
     		if (strpos($this->session->userdata('access'), '3')==true) {
     			
	     		if (!empty($clients)) 
	     		{
	     			array_push($clients,$user_id );
    				// print_r($user_id);exit;

	     			$this->db->where_in('user_id', $clients);
	     		} 
	     		else
	     		{
	     			$this->db->where("user_id",$user_id);
	     		}

	     		// $this->db->where("user_id",$user_id);
	     	}
	     	else
	     	{
	     		$this->db->where("user_id",$user_id);
	     	}
		}
		$this->db->order_by("created_date", "desc");
	

		$query = $this->db->get();
		if ($query->num_rows() > 0) {
			$allSites = array();
			foreach ($query->result() as $row) {
				$data = array();
				$data['siteData']=$row;
				$allSites[]=$data;
			}
			return $allSites;
		}
		return false;	
    }


    /*
		check subdomain is present or not
	*/
    public function checkSubdomain($name)
    {
    	$this->db->where("subdomain_name",$name);
    	$this->db->from("subdomains");
		$this->db->order_by("created_date", "desc");

    	$query = $this->db->get();
    	// echo $query->num_rows();exit;
    	$data['status'] = $query->num_rows();

    	// print_r($data);
    	return json_encode($data);
    }

    /*
		Creating subdomain
	*/
    public function updateConfig($configData,$user_id) 
    {
    	// error_reporting(0);
	    
    	$ret = array();
    	// print_r($configData);
    	// echo $configData['subdomain'];
    	// exit();
    	$subdomainName = strtolower($configData['name']);
    	$query = $this->db->from('subdomains')->where('subdomain_name', $subdomainName)->get();
    	    	
    	if( $query->num_rows() > 0 ) {
    		$ret['message'] = $this->lang->line('subdomains_error_unavailable');
    		$ret['ret'] = 0;
    		return $ret;
    	}
		


		
    	
	    //subdomain
	    $data = array(
        	'subdomain' => $subdomainName
        );


		
		$domain = $this->session->userdata('subdomain');
		if (empty($domain)){
    	$this->session->set_userdata(array('subdomain'=>$subdomainName,
											'newuser' => true
											));				
		}

		// $this->db->where('id', $this->session->userdata('user_id'));
  		$ret['ret'] = 1;
    	$ret['message'] = '';   
		try{
			
			$ftp_server = $this->config->item('ftpServer', 'subdomain');
			$ftp_username = $this->config->item('ftpUser', 'subdomain');
			$ftp_userpass = $this->config->item('ftpPass', 'subdomain');
			$ftp_conn = ftp_ssl_connect($ftp_server) or die("Could not connect to $ftp_server");
			$login = ftp_login($ftp_conn, $ftp_username, $ftp_userpass);
			ftp_pasv($ftp_conn, true);				
		
         	$subdomain = $this->create_subdomain($subdomainName);
			$insertID = $this->insert_subdomain($subdomainName,$user_id);
		
			$this->ftp_putAll($insertID,$subdomainName,$ftp_conn);
			return $insertID;
			// ftp_chmod($ftp_conn, 0755, $subdomainName);				
		}
    	catch (Exception $e){
    		$ret['message'] = $e->getMessage();
    		$ret['ret'] = 0;
		}
		
		return $ret;
    }

    /*
		Generate Unique Ids	
    */
    public function generateUniqueId($len){
    	$char = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUWXYZ123456789";
    	if($len >=26){
    		$len = 26;	
    	}
		for($i=0;$i<=$len;$i++){
			$uid .= $char[rand(0,strlen($char)-1)];	
		}
		return $uid;
    }
    /*
		Insert the subdomain in database
	*/
    public function insert_subdomain($subdomainName,$user_id)
    {
    	$subdomain_uid = $this->generateUniqueId(8);
    	$data = array(
        	'subdomain_name' => $subdomainName,
        	'user_id' => $user_id,
        	'subdomain_uid' => $subdomain_uid
        );

        $this->db->insert("subdomains",$data);
		return $this->db->insert_id();

    }


    /*
		Create the subdomain and dns zone
	*/
    private function create_subdomain($subDomain) 
    {
		
		
		
    	$subDomain = strtolower($subDomain);
		
		$buildRequest = "/frontend/paper_lantern/subdomain/doadddomain.html?rootdomain=" . $this->config->item('rootDomain', 'subdomain') . "&domain=" . $subDomain . "&dir=" . $this->config->item('primedir', 'subdomain') . '/' . $subDomain;
		$openSocket = fsockopen('localhost', 2082);
		if (!$openSocket) {
			// echo 'socket error';
			// return "Socket error";
			exit();
		}
		
		//var_dump($openSocket);
		
		$authString = $this->config->item('cPanelUser', 'subdomain') . ":" . $this->config->item('cPanelPass', 'subdomain');
		$authPass = base64_encode($authString);
		$buildHeaders = "GET " . $buildRequest . "\r\n";
		$buildHeaders .= "HTTP/1.0\r\n";
		$buildHeaders .= "Host:localhost\r\n";
		$buildHeaders .= "Authorization: Basic " . $authPass . "\r\n";
		$buildHeaders .= "\r\n";
				
		$ret = fputs($openSocket, $buildHeaders);
		//print_r($ret);
		//var_dump($ret);
		$ret = '';
		
		while (!feof($openSocket)) {
			$ret .= fgets($openSocket, 128);
		}
		fclose($openSocket);
		
		//print($ret);
		//	exit;

		$newDomain = "http://" . $subDomain . "." . $this->config->item('rootDomain', 'subdomain') . "/";
		//  return "Created subdomain $newDomain";

		return $newDomain;

	}


	/*
		Upload or create the file in subdomain directory
	*/
	public function ftp_putAll( $subdomain_id,$subDomain,$ftp_conn) 
	{
		

		$dst_dir  = $subDomain;

		// echo $subdomain_id;
		// ftp_mkdir($conn_id,$dst_dir);

			// $htaccess_data = file_get_contents('./subdomaindata/htaccess.txt');
			$src_dir = './subdomaindata/';


            ftp_mkdir($ftp_conn,$dst_dir); // create directories that do not yet exist

            $file_name = file_put_contents($src_dir.$subdomain_id.".txt", $subdomain_id); // -------------------------------------------------
            // Creating the htaccess file

   //           if(!$success_htaccess) {
	
			// 	$success = ftp_put($ftp_conn, 'files.htaccess', $path . '/files.htaccess', FTP_BINARY);
			
			// }


            $upload = ftp_put($ftp_conn, $dst_dir."/id.txt",$src_dir.$subdomain_id.".txt" , FTP_ASCII); // put the file ------------------------------

            $upload = ftp_put($ftp_conn, $dst_dir."/Route.php", $src_dir."/Route.php", FTP_ASCII); // put the Route files

            $upload = ftp_put($ftp_conn, $dst_dir."/index.php", $src_dir."/index.php", FTP_ASCII); // put the index file


            // $upload = ftp_put($ftp_conn, $dst_dir."/home.php", $src_dir."/home.php", FTP_ASCII); // put the Home file

            // $upload = ftp_put($ftp_conn, $dst_dir."/about.php", $src_dir."/about.php", FTP_ASCII); // put the index files

            // $upload = ftp_put($ftp_conn, $dst_dir."/contact.php", $src_dir."/contact.php", FTP_ASCII); // put the index files
            $upload = ftp_put($ftp_conn, $dst_dir."/webpage.php", $src_dir."/webpage.php", FTP_ASCII); // put the index files

            // $upload = ftp_put($ftp_conn, $dst_dir."/story.php", $src_dir."/story.php", FTP_ASCII); // put the index files
			
			ftp_close($ftp_conn);
	}
}

?>



