<?php

/**
 * This is the model class for table "tbljvzoolistener".
 *
 * The followings are the available columns in table 'tbljvzoolistener':
 * @property string $JvZooLientenerID
 * @property string $ReceivedOn
 * @property string $Content
 * @property string $CCustName
 * @property string $CCustState
 * @property string $CCustCc
 * @property string $CCustEmail
 * @property string $CProdItem
 * @property string $CProdTitle
 * @property string $CProdType
 * @property string $CTransaction
 * @property string $CTransAffiliate
 * @property string $CTransAmount
 * @property string $CTransPaymentMethod
 * @property string $CTransVendor
 * @property string $CTransReceipt
 * @property string $CUpsellReceipt
 * @property string $CAffitID
 * @property string $CVendThru
 * @property string $CVerify
 * @property string $CTransTime
 * @property string $UpdatedOn
 * @property int $SubadminUserID
 */
class JvZooListener extends CActiveRecord
{
	/**
	 * Returns the static model of the specified AR class.
	 * @param string $className active record class name.
	 * @return JvZooListener the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'tbljvzoolistener';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('Content', 'length', 'max'=>2000),
			array('SubadminUserID', 'numerical', 'integerOnly'=>true),
			array('CCustName', 'length', 'max'=>520),
			array('CCustState, CCustCc', 'length', 'max'=>2),
			array('CCustEmail, CProdTitle', 'length', 'max'=>255),
			array('CProdItem', 'length', 'max'=>15),
			array('CProdType', 'length', 'max'=>11),
			array('CTransaction', 'length', 'max'=>15),
			array('CTransAffiliate, CTransAmount, CTransVendor', 'length', 'max'=>10),
			array('CTransPaymentMethod', 'length', 'max'=>4),
			array('CTransReceipt', 'length', 'max'=>22),
			array('CUpsellReceipt', 'length', 'max'=>13),
			array('CAffitID', 'length', 'max'=>24),
			array('CVendThru', 'length', 'max'=>1024),
			array('CVerify', 'length', 'max'=>8),
			array('ReceivedOn, CTransTime, UpdatedOn', 'safe'),
			// The following rule is used by search().
			// Please remove those attributes that should not be searched.
			array('JvZooLientenerID, ReceivedOn, Content, CCustName, CCustState, CCustCc, CCustEmail, CProdItem, CProdTitle, CProdType, CTransaction, CTransAffiliate, CTransAmount, CTransPaymentMethod, CTransVendor, CTransReceipt, CUpsellReceipt, CAffitID, CVendThru, CVerify, CTransTime, UpdatedOn, SubadminUserID', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'JvZooLientenerID' => 'Jv Zoo Lientener',
			'ReceivedOn' => 'Received On',
			'Content' => 'Content',
			'CCustName' => 'Ccust Name',
			'CCustState' => 'Ccust State',
			'CCustCc' => 'Ccust Cc',
			'CCustEmail' => 'Ccust Email',
			'CProdItem' => 'Cprod Item',
			'CProdTitle' => 'Cprod Title',
			'CProdType' => 'Cprod Type',
			'CTransaction' => 'Ctransaction',
			'CTransAffiliate' => 'Ctrans Affiliate',
			'CTransAmount' => 'Ctrans Amount',
			'CTransPaymentMethod' => 'Ctrans Payment Method',
			'CTransVendor' => 'Ctrans Vendor',
			'CTransReceipt' => 'Ctrans Receipt',
			'CUpsellReceipt' => 'Cupsell Receipt',
			'CAffitID' => 'Caffit',
			'CVendThru' => 'Cvend Thru',
			'CVerify' => 'Cverify',
			'CTransTime' => 'Ctrans Time',
			'UpdatedOn' => 'Updated On',
			'SubadminUserID' => 'Subadmin User',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 * @return CActiveDataProvider the data provider that can return the models based on the search/filter conditions.
	 */
	public function search()
	{
		// Warning: Please modify the following code to remove attributes that
		// should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('JvZooLientenerID',$this->JvZooLientenerID,true);
		$criteria->compare('ReceivedOn',$this->ReceivedOn,true);
		$criteria->compare('Content',$this->Content,true);
		$criteria->compare('CCustName',$this->CCustName,true);
		$criteria->compare('CCustState',$this->CCustState,true);
		$criteria->compare('CCustCc',$this->CCustCc,true);
		$criteria->compare('CCustEmail',$this->CCustEmail,true);
		$criteria->compare('CProdItem',$this->CProdItem,true);
		$criteria->compare('CProdTitle',$this->CProdTitle,true);
		$criteria->compare('CProdType',$this->CProdType,true);
		$criteria->compare('CTransaction',$this->CTransaction,true);
		$criteria->compare('CTransAffiliate',$this->CTransAffiliate,true);
		$criteria->compare('CTransAmount',$this->CTransAmount,true);
		$criteria->compare('CTransPaymentMethod',$this->CTransPaymentMethod,true);
		$criteria->compare('CTransVendor',$this->CTransVendor,true);
		$criteria->compare('CTransReceipt',$this->CTransReceipt,true);
		$criteria->compare('CUpsellReceipt',$this->CUpsellReceipt,true);
		$criteria->compare('CAffitID',$this->CAffitID,true);
		$criteria->compare('CVendThru',$this->CVendThru,true);
		$criteria->compare('CVerify',$this->CVerify,true);
		$criteria->compare('CTransTime',$this->CTransTime,true);
		$criteria->compare('UpdatedOn',$this->UpdatedOn,true);
		$criteria->compare('SubadminUserID',$this->SubadminUserID);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}
}