<?php

/**
 * LoginForm class.
 * LoginForm is the data structure for keeping
 * user login form data. It is used by the 'login' action of 'SiteController'.
 */
class Subscribe
{
	//Search Params
	public $mailerType;
	public $param1;
	public $param2;
	public $param3;
	public $param4;
	public $param5;
	public $email;
	public $name;

	/**
	 * Declares the validation rules.
	 * The rules state that username and password are required,
	 * and password needs to be authenticated.
	 */
	public function rules()
	{
		return array(
			array('email', 'email'),
			array('name', 'name'),
			array('mailerType, param1, email', 'required'),
			array('param2, param3, param4 ,param5 ', 'safe'),
		);
	}

	/**
	 * Declares attribute labels.
	 */
	public function attributeLabels()
	{
		return array(
			'email'=>'Email',
			'name'=>'Name',
			'mailerType'=>'Mailer Type',
			'param1'=>'Parameter 1',
			'param2'=>'Parameter 2',
			'param3'=>'Parameter 3',
			'param4'=>'Parameter 4',
			'param5'=>'Parameter 5',
		);
	}
}
