<?php
header("Content-Type:application/json");

function icontact_addcontact($appid, $apiusername, $apipassword, $listid, $name, $email) {
	
	global $options;
	$data = icontact_makecall($appid, $apiusername, $apipassword, '/a/', null, 'accounts');
	if (!empty($data['errors'])) return;
	$account = $data['response'][0];
	if (empty($account) || intval($account->enabled != 1)) return;
	$data = icontact_makecall($appid, $apiusername, $apipassword, '/a/'.$account->accountId.'/c/', null, 'clientfolders');
	if (!empty($data['errors'])) return;
	$client = $data['response'][0];
	if (empty($client)) return;
	$contact['email'] = $email;
	if ($options['disable_name'] != 'on') $contact['firstName'] = $name;
	$contact['status'] = 'normal';
	$data = icontact_makecall($appid, $apiusername, $apipassword, '/a/'.$account->accountId.'/c/'.$client->clientFolderId.'/contacts', array($contact), 'contacts');
	if (!empty($data['errors'])) return;
	$contact = $data['response'][0];
	if (empty($contact)) return;
	$subscriber['contactId'] = $contact->contactId;
	$subscriber['listId'] = $listid;
	$subscriber['status'] = 'normal';
	$data = icontact_makecall($appid, $apiusername, $apipassword, '/a/'.$account->accountId.'/c/'.$client->clientFolderId.'/subscriptions', array($subscriber), 'subscriptions');
}
if(isset($_REQUEST['appid']) && isset($_REQUEST['appusername']) && isset($_REQUEST['appass'])){
	
$lists=icontact_getlists($_REQUEST['appid'], $_REQUEST['appusername'], $_REQUEST['appass']);

 
echo json_encode($lists); die;
}
function icontact_getlists($appid, $apiusername, $apipassword) {
	global $options;
	//echo $appid;
	$data = icontact_makecall($appid, $apiusername, $apipassword, '/a/', null, 'accounts');
	if (!empty($data['errors'])) return array();
	$account = $data['response'][0];
	if (empty($account) || intval($account->enabled != 1)) return;
	$data = icontact_makecall($appid, $apiusername, $apipassword, '/a/'.$account->accountId.'/c/', null, 'clientfolders');
	if (!empty($data['errors'])) return array();
	$client = $data['response'][0];
	if (empty($client)) return array();
	$data = icontact_makecall($appid, $apiusername, $apipassword, '/a/'.$account->accountId.'/c/'.$client->clientFolderId.'/lists', array(), 'lists');
	if (!empty($data['errors'])) return array();
	if (!is_array($data['response'])) return array();
	$lists = array();
	foreach ($data['response'] as $list) {
		$lists[$list->listId] = $list->name;
	}
	return $lists;
}
function icontact_makecall($appid, $apiusername, $apipassword, $resource, $postdata = null, $returnkey = null) {
	$return = array();
	$url = "https://app.icontact.com/icp".$resource;
	$headers = array(
		'Except:', 
		'Accept:  application/json', 
		'Content-type:  application/json', 
		'Api-Version:  2.2',
		'Api-AppId:  '.$appid, 
		'Api-Username:  '.$apiusername, 
		'Api-Password:  '.$apipassword
	);
	$handle = curl_init();
	curl_setopt($handle, CURLOPT_HTTPHEADER, $headers);
	curl_setopt($handle, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($handle, CURLOPT_SSL_VERIFYPEER, false);
	if (!empty($postdata)) {
		curl_setopt($handle, CURLOPT_POST, true);
		curl_setopt($handle, CURLOPT_POSTFIELDS, json_encode($postdata));
	}
	curl_setopt($handle, CURLOPT_URL, $url);
	if (!$response_json = curl_exec($handle)) {
		$return['errors'][] = 'Unable to execute the cURL handle.';
	}
	if (!$response = json_decode($response_json)) {
		$return['errors'][] = 'The iContact API did not return valid JSON.';
	}
	curl_close($handle);
	if (!empty($response->errors)) {
		foreach ($response->errors as $error) {
			$return['errors'][] = $error;
		}
	}
	if (!empty($return['errors'])) return $return;
	if (empty($returnkey)) {
		$return['response'] = $response;
	} else {
		$return['response'] = $response->$returnkey;
	}
	return $return;
}

if(isset($_REQUEST['appurl']) && isset($_REQUEST['appkey']) ){
	
$lists=activecampaign_getlists($_REQUEST['appurl'], $_REQUEST['appkey']);

 
echo json_encode($lists); die;
}






function activecampaign_getlists($_url, $_key) {
	$request = http_build_query(array(
		'api_action' => 'list_list',
		'api_key' => $_key,
		'api_output' => 'serialize',
		'ids' => 'all'
	));

	$_url = str_replace('https://', 'http://', $_url);
	$curl = curl_init($_url.'/admin/api.php?api_action=list_list');
	curl_setopt($curl, CURLOPT_POST, 1);
	curl_setopt($curl, CURLOPT_POSTFIELDS, $request);
	curl_setopt($curl, CURLOPT_TIMEOUT, 20);
	curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($curl, CURLOPT_FORBID_REUSE, 1);
	curl_setopt($curl, CURLOPT_FRESH_CONNECT, 1);
	curl_setopt($curl, CURLOPT_HEADER, 0);
								
	$response = curl_exec($curl);
	
	curl_close($curl);
	$result = unserialize($response);
	if (!is_array($result) || (isset($result['result_code']) && $result['result_code'] != 1)) return array();
	$lists = array();
	foreach ($result as $key => $value) {
		if (is_array($value)) {
			$lists[$value['id']] = $value['name'];
		}
	}
	return $lists;
}

if(isset($_REQUEST['lurl']) && isset($_REQUEST['lusername'])  && isset($_REQUEST['ltoken'])){
	
$lists=interspire_getlists($_REQUEST['lurl'], $_REQUEST['lusername'],$_REQUEST['ltoken']);

 
echo json_encode($lists); die;
}
function interspire_getlists($_url, $_username, $_token) {
	$lists = array();
	try {
		$xml = '
<xmlrequest>
	<username>'.$_username.'</username>
	<usertoken>'.$_token.'</usertoken>
	<requesttype>lists</requesttype>
	<requestmethod>GetLists</requestmethod>
	<details>
	</details>
</xmlrequest>';
		$curl = curl_init($_url);
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($curl, CURLOPT_FORBID_REUSE, 1);
		curl_setopt($curl, CURLOPT_FRESH_CONNECT, 1);
		curl_setopt($curl, CURLOPT_HEADER, 0);
		curl_setopt($curl, CURLOPT_POST, 1);
		curl_setopt($curl, CURLOPT_POSTFIELDS, $xml);
		$response = curl_exec($curl);
		curl_close($curl);
		$p = xml_parser_create();
		xml_parse_into_struct($p, $response, $values, $index);
		xml_parser_free($p);
		if (isset($index['STATUS']) && $values[$index['STATUS'][0]]['value'] == 'SUCCESS') {
			$i = 0;
			foreach ($index['LISTID'] as $idx) {
				$lists[$values[$idx]['value']] = $values[$index['NAME'][$i]]['value'];
				$i++;
			}
		}
		ksort($lists);
	} catch (Exception $e) {
	}
	return $lists;
}
if(isset($_REQUEST['furl']) && isset($_REQUEST['fusername'])  && isset($_REQUEST['ftoken'])){
	
$fields=interspire_getfields($_REQUEST['furl'], $_REQUEST['fusername'],$_REQUEST['ftoken']);

 
echo json_encode($fields); die;
}
function interspire_getfields($_url, $_username, $_token, $_listid) {
	$fields = array();
	try {
		$xml = '
<xmlrequest>
	<username>'.$_username.'</username>
	<usertoken>'.$_token.'</usertoken>
	<requesttype>lists</requesttype>
	<requestmethod>GetCustomFields</requestmethod>
	<details>
		<listids>'.$_listid.'</listids>
	</details>
</xmlrequest>';
		$curl = curl_init($_url);
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($curl, CURLOPT_FORBID_REUSE, 1);
		curl_setopt($curl, CURLOPT_FRESH_CONNECT, 1);
		curl_setopt($curl, CURLOPT_HEADER, 0);
		curl_setopt($curl, CURLOPT_POST, 1);
		curl_setopt($curl, CURLOPT_POSTFIELDS, $xml);
		$response = curl_exec($curl);
		curl_close($curl);
		$p = xml_parser_create();
		xml_parse_into_struct($p, $response, $values, $index);
		xml_parser_free($p);
		if (isset($index['STATUS']) && $values[$index['STATUS'][0]]['value'] == 'SUCCESS') {
			$i = 0;
			foreach ($index['FIELDID'] as $idx) {
				$fields[$values[$idx]['value']] = $values[$index['NAME'][$i]]['value'];
				$i++;
			}
		}
		ksort($fields);
	} catch (Exception $e) {
	}
	return $fields;
}

function ic_mail($_email, $_subject, $_body, $_replyto = '') {
	global $options;
	//$_body = str_replace(array("\n", "\r"), array("<br />", ""), $_body);
	if ($options['mail_method'] == 'mail') {
		$mail_headers = "Content-Type: text/html; charset=utf-8\r\n";
		$mail_headers .= "From: ".$options['from_name']." <".$options['mail_from_email'].">\r\n";
		if (!empty($_replyto)) $mail_headers .= "Reply-To: ".$_replyto."\r\n";
		$mail_headers .= "X-Mailer: PHP/".phpversion()."\r\n";
		$result = mail($_email, $_subject, $_body, $mail_headers);
	} else if ($options['mail_method'] == 'smtp') {
		include_once(dirname(__FILE__).'/class.phpmailer.php');
		$mail = new PHPMailer();
		$mail->IsSMTP();
		$mail->IsHTML(true);
		$mail->SMTPDebug  = 0;
		$mail->Host       = $options['smtp_server'];
		$mail->Port       = $options['smtp_port'];
		if ($options['smtp_secure'] != 'none') {
			$mail->SMTPSecure = $options['smtp_secure'];
		}
		$mail->SMTPAuth   = true;
		$mail->Username   = $options['smtp_username'];
		$mail->Password   = $options['smtp_password'];
		$mail->SetFrom($options['smtp_username'], $options['from_name']);
		$mail->AddAddress($_email, $_email);
		if (!empty($_replyto)) $mail->AddReplyTo($_replyto);
		$mail->Subject = $_subject;
		$mail->CharSet = 'utf-8';
		$mail->Body = $_body;
		$mail->AltBody = $_body;
		$mail->Send();
	}
}

function install() {
	global $icdb;
	$add_default = false;
	$table_name = $icdb->prefix."popups";
	if($icdb->get_var("SHOW TABLES LIKE '".$table_name."'") != $table_name) {
		$sql = "CREATE TABLE ".$table_name." (
			id int(11) NOT NULL auto_increment,
			str_id varchar(31) collate latin1_general_cs NULL,
			title varchar(255) collate utf8_unicode_ci NULL,
			width int(11) NULL default '640',
			height int(11) NULL default '400',
			options longtext collate utf8_unicode_ci NULL,
			created int(11) NULL,
			blocked int(11) NULL default '0',
			deleted int(11) NULL default '0',
			UNIQUE KEY  id (id)
		);";
		$icdb->query($sql);
		$add_default = true;
	}
	$table_name = $icdb->prefix."layers";
	if($icdb->get_var("SHOW TABLES LIKE '".$table_name."'") != $table_name) {
		$sql = "CREATE TABLE ".$table_name." (
			id int(11) NOT NULL auto_increment,
			popup_id int(11) NULL,
			title varchar(255) collate utf8_unicode_ci NULL,
			content longtext collate utf8_unicode_ci NULL,
			zindex int(11) NULL default '5',
			details longtext collate utf8_unicode_ci NULL,
			created int(11) NULL,
			deleted int(11) NULL default '0',
			UNIQUE KEY  id (id)
		);";
		$icdb->query($sql);
	}
	$table_name = $icdb->prefix . "subscribers";
	if($icdb->get_var("SHOW TABLES LIKE '".$table_name."'") != $table_name) {
		$sql = "CREATE TABLE ".$table_name." (
			id int(11) NOT NULL auto_increment,
			popup_id int(11) NULL,
			name varchar(255) collate utf8_unicode_ci NULL,
			email varchar(255) collate utf8_unicode_ci NULL,
			phone varchar(255) collate utf8_unicode_ci NULL,
			message longtext collate utf8_unicode_ci NULL,
			created int(11) NULL,
			deleted int(11) NULL default '0',
			UNIQUE KEY  id (id)
		);";
		$icdb->query($sql);
	}
	if ($icdb->get_var("SHOW COLUMNS FROM ".$icdb->prefix."subscribers LIKE 'phone'") != 'phone') {
		$sql = "ALTER TABLE ".$icdb->prefix."subscribers ADD phone varchar(255) collate utf8_unicode_ci NULL";
		$icdb->query($sql);
	}
	if ($icdb->get_var("SHOW COLUMNS FROM ".$icdb->prefix."subscribers LIKE 'message'") != 'message') {
		$sql = "ALTER TABLE ".$icdb->prefix."subscribers ADD message longtext collate utf8_unicode_ci NULL";
		$icdb->query($sql);
	}
	$table_name = $icdb->prefix."options";
	if($icdb->get_var("SHOW TABLES LIKE '".$table_name."'") != $table_name) {
		$sql = "CREATE TABLE IF NOT EXISTS ".$table_name." (
			id int(11) NOT NULL AUTO_INCREMENT,
			options_key varchar(255) COLLATE utf8_unicode_ci NOT NULL,
			options_value text COLLATE utf8_unicode_ci NOT NULL,
			UNIQUE KEY id (id)
		) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;";
		$icdb->query($sql);
	}
	$table_name = $icdb->prefix."sessions";
	if($icdb->get_var("SHOW TABLES LIKE '".$table_name."'") != $table_name) {
		$sql = "CREATE TABLE IF NOT EXISTS ".$table_name." (
			id int(11) NOT NULL AUTO_INCREMENT,
			ip varchar(31) COLLATE utf8_unicode_ci NOT NULL,
			session_id varchar(255) COLLATE utf8_unicode_ci NOT NULL,
			registered int(11) NOT NULL,
			valid_period int(11) NOT NULL,
			UNIQUE KEY id (id)
		) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;";
		$icdb->query($sql);
	}
	if ($add_default) {
		if (file_exists(dirname(dirname(__FILE__)).'/default') && is_dir(dirname(dirname(__FILE__)).'/default')) {
			$dircontent = scandir(dirname(dirname(__FILE__)).'/default');
			for ($i=0; $i<sizeof($dircontent); $i++) {
				if ($dircontent[$i] != "." && $dircontent[$i] != ".." && $dircontent[$i] != "index.html" && $dircontent[$i] != ".htaccess") {
					if (is_file(dirname(dirname(__FILE__)).'/default/'.$dircontent[$i])) {
						$lines = file(dirname(dirname(__FILE__)).'/default/'.$dircontent[$i]);
						if (sizeof($lines) != 3) continue;
						$version = intval(trim($lines[0]));
						if ($version > intval(EXPORT_VERSION)) continue;
						$md5_hash = trim($lines[1]);
						$popup_data = trim($lines[2]);
						$popup_data = base64_decode($popup_data);
						if (!$popup_data || md5($popup_data) != $md5_hash) continue;
						$popup = unserialize($popup_data);
						$popup_details = $popup['popup'];
						$symbols = '123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
						$str_id = '';
						for ($j=0; $j<16; $j++) {
							$str_id .= $symbols[rand(0, strlen($symbols)-1)];
						}
						$sql = "INSERT INTO ".$icdb->prefix."popups (str_id, title, width, height, options, created, blocked, deleted) 
							VALUES (
							'".$str_id."', 
							'".$icdb->escape_string($popup_details['title'])."', 
							'".intval($popup_details['width'])."', 
							'".intval($popup_details['height'])."', 
							'".$icdb->escape_string($popup_details['options'])."', 
							'".time()."', '1', '0')";
						$icdb->query($sql);
						$popup_id = $icdb->insert_id;
						$layers = $popup['layers'];
						if (sizeof($layers) > 0) {
							foreach ($layers as $layer) {
								$sql = "INSERT INTO ".$icdb->prefix."layers (
									popup_id, title, content, zindex, details, created, deleted) VALUES (
									'".$popup_id."',
									'".$icdb->escape_string($layer['title'])."',
									'".$icdb->escape_string($layer['content'])."',
									'".$icdb->escape_string($layer['zindex'])."',
									'".$icdb->escape_string($layer['details'])."',
									'".time()."', '0')";
								$icdb->query($sql);
							}
						}
					}
				}
			}
		}
	}
}
function remove_dir($_dir) { 
	$files = array_diff(scandir($_dir), array('.','..')); 
	foreach ($files as $file) { 
		if (is_dir($_dir.'/'.$file)) {
			$this->remove_dir($_dir.'/'.$file);
		} else {
			unlink($_dir.'/'.$file); 
		}
	}
	return rmdir($_dir);
} 
function import_zip($_filename, $_url_base, $_title = '') {
	global $icdb, $default_layer_options;
	error_reporting(0);
	$str_id = random_string(16);
	if (!class_exists('ZipArchive')) {
		return array('status' => 'error', 'message' => 'This operation <strong>requires</strong> <em>ZipArchive</em> class. It is <strong>not found</strong>.');
	}
	if (!is_dir(dirname(dirname(__FILE__)).'/files/temp')) {
		return array('status' => 'error', 'message' => 'Please create directoris: <strong>'.dirname(dirname(__FILE__)).'/files</strong> and <strong>'.dirname(dirname(__FILE__)).'/files/temp</strong> and set their permissions as <strong>0777</strong>.');
	}
	$temp_dir = dirname(dirname(__FILE__)).'/files/'.$str_id;
	if (!mkdir($temp_dir, 0777, true)) {
		return array('status' => 'error', 'message' => 'Make sure that the following folder has write permission: '.dirname(dirname(__FILE__)).'/files');
	}
	$zip = new ZipArchive;
	if ($zip->open($_filename) === true) {
		$zip->extractTo($temp_dir);
		$zip->close();
	} else {
		return array('status' => 'error', 'message' => 'Can not unzip archive into folder '.$temp_dir);
	}
	if (!file_exists($temp_dir.'/popup.txt')) {
		remove_dir($temp_dir);
		return array('status' => 'error', 'message' => 'Please make sure that you uploaded valid popup file. Error #1.');
	}
	$lines = file($temp_dir.'/popup.txt');
	if (sizeof($lines) != 3) {
		remove_dir($temp_dir);
		return array('status' => 'error', 'message' => 'Please make sure that you uploaded valid popup file. Error #2.');
	}
	$version = intval(trim($lines[0]));
	if ($version > intval(EXPORT_VERSION)) {
		remove_dir($temp_dir);
		return array('status' => 'error', 'message' => 'Please make sure that you uploaded valid popup file. Error #3.');
	}
	$md5_hash = trim($lines[1]);
	$popup_data = trim($lines[2]);
	$popup_data = base64_decode($popup_data);
	if (!$popup_data || md5($popup_data) != $md5_hash) {
		remove_dir($temp_dir);
		return array('status' => 'error', 'message' => 'Please make sure that you uploaded valid popup file. Error #4.');
	}
	$popup = unserialize($popup_data);
	if ($popup === false) {
		remove_dir($temp_dir);
		return array('status' => 'error', 'message' => 'Please make sure that you uploaded valid popup file. Error #5.');
	}
	$popup_details = $popup['popup'];
	if (!empty($_title)) $popup_details['title'] = $_title;
		
	$upload_url = $_url_base.'files/'.$str_id;
	if (strtolower(substr($upload_url, 0, 7)) == 'http://') $upload_url = substr($upload_url, 5);
	else if (strtolower(substr($upload_url, 0, 8)) == 'https://') $upload_url = substr($upload_url, 6);
	$sql = "INSERT INTO ".$icdb->prefix."popups (str_id, title, width, height, options, created, blocked, deleted) 
		VALUES (
		'".$str_id."', 
		'".$icdb->escape_string($popup_details['title'])."', 
		'".intval($popup_details['width'])."', 
		'".intval($popup_details['height'])."', 
		'".$icdb->escape_string($popup_details['options'])."', 
		'".time()."', '1', '0')";
	$icdb->query($sql);
	$popup_id = $icdb->insert_id;
	$layers = $popup['layers'];
	if (sizeof($layers) > 0) {
		foreach ($layers as $layer) {
			$layer_options = unserialize($layer['details']);
			if (is_array($layer_options)) $layer_options = array_merge($default_layer_options, $layer_options);
			else $layer_options = $default_layer_options;
			$layer_options['content'] = str_replace('ULP-UPLOADS-DIR', $upload_url, $layer_options['content']);
			$layer_options['background_image'] = str_replace('ULP-UPLOADS-DIR', $upload_url, $layer_options['background_image']);
			$layer['content'] = str_replace('ULP-UPLOADS-DIR', $upload_url, $layer['content']);
			$layer['details'] = serialize($layer_options);
			$sql = "INSERT INTO ".$icdb->prefix."layers (
				popup_id, title, content, zindex, details, created, deleted) VALUES (
				'".$popup_id."',
				'".$icdb->escape_string($layer['title'])."',
				'".$icdb->escape_string($layer['content'])."',
				'".$icdb->escape_string($layer['zindex'])."',
				'".$icdb->escape_string($layer['details'])."',
				'".time()."', '0')";
			$icdb->query($sql);
		}
	}
	return true;
}

?>