<?php 
require_once('./extras/Subscribe.php');
require_once('./extras/SendReach.php');
require_once('./inc/functions.php');
require_once('./extras/GotoWebinar.php');
require_once('./inc/vendor/autoload.php');
use GuzzleHttp\Client;
define('BASE_URL','https://api.aweber.com/1.0/');
define('OAUTH_URL','https://auth.aweber.com/oauth2/');
define('TOKEN_URL','https://auth.aweber.com/oauth2/token');
header('Content-Type: text/html; charset=utf-8');

$subscribe = new Subscribe();
			
//print_r($_POST);
//exit;
		
if(!isset($_POST['mailerType']) || !isset($_POST['email']) || !isset($_POST['param1']))
{
	echo json_encode(array('error'=>1, 'message'=>'Invalid Parameters.'));
	exit;
}else{
	$subscribe->mailerType=$_POST['mailerType'];
	$subscribe->param1=$_POST['param1'];
	if (isset($_POST['param2'])) $subscribe->param2=$_POST['param2'];
	if (isset($_POST['param3'])) $subscribe->param3=$_POST['param3'];
	if (isset($_POST['param4'])) $subscribe->param4=$_POST['param4'];
	$subscribe->email=$_POST['email'];
	if (isset($_POST['name'])) 
		$subscribe->name = preg_replace('/[^a-z]/i', '', iconv("UTF-8", "US-ASCII//TRANSLIT", $_POST['name']));
	else
		$subscribe->name = $_POST['email'];
	
	
	//mailer getResponse
	if ($subscribe->mailerType == 1){
		try{
			//require_once('./extras/JsonRPCClient.php');
			require_once('./extras/GetResponseAPI.class.php');
                        	

			# your API key is available at
			# https://app.getresponse.com/my_api_key.html
			$api_key = $subscribe->param1;
			
			$api = new GetResponse($api_key);
		
			//echo $subscribe->param2.$subscribe->name.$subscribe->email;
			
            $response=$api->addContact($subscribe->param3,$subscribe->name,$subscribe->email);

            if(@array_key_exists("httpStatus",$response)){
				echo json_encode(array('error'=>$response['httpStatus'], 'message'=>$response['message']));
				exit;
			}else{
				echo json_encode(array('success'=>1, 'message'=>'Thank you for registration'));
				exit;
			}          
		}
		catch (Exception $e){
			
			/*print("<pre>");
			print_r($e);
			print("</pre>");
			exit;*/
			
			$pos = strpos($e->getMessage(), 'Contact already added');
			$pos1 = strpos($e->getMessage(), 'Contact already queued');
			if ($pos === false && $pos1 === false){
				echo json_encode(array('error'=>30, 'message'=>'Error subscribing on GetResponse. '. $e->getMessage()));
			}else{
				echo json_encode(array('error'=>33, 'message'=>'This email is already subscribed on this campaign.'));
			}
			exit;
		}
	}

	//ActiveCampaign
	if ($subscribe->mailerType == 2){
		
		try{
			$url=$subscribe->param2;
			$AppKey=$subscribe->param1;
			$name=$subscribe->name;
			$email=$subscribe->email;	
		
			$ListId=$subscribe->param3;
		
			$params = array(

				// the API Key can be found on the "Your Settings" page under the "API" tab.
				// replace this with your API Key
				'api_key'      => $AppKey,

				// this is the action that adds a contact
				'api_action'   => 'contact_add',

				// define the type of output you wish to get back
				// possible values:
				// - 'xml'  :      you have to write your own XML parser
				// - 'json' :      data is returned in JSON format and can be decoded with
				//                 json_decode() function (included in PHP since 5.2.0)
				// - 'serialize' : data is returned in a serialized format and can be decoded with
				//                 a native unserialize() function
				'api_output'   => 'serialize',
			);

			// here we define the data we are posting in order to perform an update
			$post = array(
				'email'                    => $email,
				'first_name'               => $name,
				'last_name'                => '',
				'phone'                    => '',
				'orgname'                  => '',
				'tags'                     => 'api',
				'ip4'                    => $_SERVER['REMOTE_ADDR'],

				// any custom fields
				//'field[345,0]'           => 'field value', // where 345 is the field ID
				//'field[%PERS_1%,0]'      => 'field value', // using the personalization tag instead (make sure to encode the key)

				// assign to lists:
				'p['.$ListId.']'                   => $ListId, // example list ID (REPLACE '123' WITH ACTUAL LIST ID, IE: p[5] = 5)
				'status['.$ListId.']'              => 1, // 1: active, 2: unsubscribed (REPLACE '123' WITH ACTUAL LIST ID, IE: status[5] = 1)
				//'form'          => 1001, // Subscription Form ID, to inherit those redirection settings
				//'noresponders[123]'      => 1, // uncomment to set "do not send any future responders"
				//'sdate[123]'             => '2009-12-07 06:00:00', // Subscribe date for particular list - leave out to use current date/time
				// use the folowing only if status=1
				'instantresponders['.$ListId.']' => 1, // set to 0 to if you don't want to sent instant autoresponders
				//'lastmessage[123]'       => 1, // uncomment to set "send the last broadcast campaign"

				//'p[]'                    => 345, // some additional lists?
				//'status[345]'            => 1, // some additional lists?
			);

			// This section takes the input fields and converts them to the proper format
			$query = "";
			foreach( $params as $key => $value ) $query .= $key . '=' . urlencode($value) . '&';
			$query = rtrim($query, '& ');

			// This section takes the input data and converts it to the proper format
			$data = "";
			foreach( $post as $key => $value ) $data .= $key . '=' . urlencode($value) . '&';
			$data = rtrim($data, '& ');

			// clean up the url
			$url = rtrim($url, '/ ');
			// This sample code uses the CURL library for php to establish a connection,
			// submit your request, and show (print out) the response.

			if ( !function_exists('curl_init') ) die('CURL not supported. (introduced in PHP 4.0.2)');

			// If JSON is used, check if json_decode is present (PHP 5.2.0+)
			if ( $params['api_output'] == 'json' && !function_exists('json_decode') ) {
				die('JSON not supported. (introduced in PHP 5.2.0)');
			}

			// define a final API request - GET
			$api = $url . '/admin/api.php?' . $query;

			$request = curl_init($api); // initiate curl object
			curl_setopt($request, CURLOPT_HEADER, 0); // set to 0 to eliminate header info from response
			curl_setopt($request, CURLOPT_RETURNTRANSFER, 1); // Returns response data instead of TRUE(1)
			curl_setopt($request, CURLOPT_POSTFIELDS, $data); // use HTTP POST to send form data
			curl_setopt($request, CURLOPT_SSL_VERIFYPEER, FALSE); // uncomment if you get no gateway response and are using HTTPS
			curl_setopt($request, CURLOPT_FOLLOWLOCATION, true);

			$response = (string)curl_exec($request); // execute curl post and store results in $response

			// additional options may be required depending upon your server configuration
			// you can find documentation on curl options at http://www.php.net/curl_setopt
			curl_close($request); // close curl object

			if ( !$response ) {
				die('Nothing was returned. Do you have a connection to Email Marketing server?');
			}

			// This line takes the response and breaks it into an array using:
			// JSON decoder
			//$result = json_decode($response);
			// unserializer
			$result = unserialize($response);
			// XML parser...
			// ...

			// Result info that is always returned
			//echo 'Result: ' . ( $result['result_code'] ? 'SUCCESS' : 'FAILED' ) . '<br />';
			//echo 'Message: ' . $result['result_message'] . '<br />';
			if($result['result_code']==0){
				
				echo json_encode(array('error'=>41, 'message'=>$result['result_message']));
			}else{
				
				echo json_encode(array('success'=>1));
			}

							
						exit;
			}
			catch(Exception $e){
				echo json_encode(array('error'=>41, 'message'=>'Error subscribing on Active Campaign. '. $e->getMessage()));
				exit;
					
			}
	
		}
	
	//MailChimp
	if ($subscribe->mailerType == 3){
		try{
	
			$email = $subscribe->email;
			$status = 'subscribed';
			$firstname = $subscribe->name;
			$list_id =$subscribe->param2;
			$api_key =$subscribe->param1;
			//print_r($data);exit;
			$response = json_decode(shai_mailchimp_subscriber_status($email, $status, $list_id, $api_key, $firstname ));
			//print_r($response);exit;
			if($response->status == 400){
				echo json_encode(array('error'=>21 ,'message'=>'Error subscribing on MailChimp.'));
				exit;
			}
			elseif( $response->status == 'subscribed' )
			{
				echo json_encode(array('success'=>1, 'message'=>'Thank you, ' . $response->merge_fields->FNAME . '. You have subscribed successfully'));
				exit;
			}

		}
		catch (Exception $e){
			echo json_encode(array('error'=>20, 'message'=>'Error subscribing on MailChimp. '. $e->getMessage()));
			exit;
		}
	}
	
	//Aweber
	if ($subscribe->mailerType == 4){
		
		$data = array();
		$name = $subscribe->name;
		$email = $subscribe->email;
		$refresh_token = $subscribe->param1;
		$subsUrl = $subscribe->param3;
		try{
			// Create a Guzzle client
			$client = new GuzzleHttp\Client();
			
			$clientId = 'VfZP7A5gVZYAOOeF0iMrLd6I1k0LTYdD';
			$clientSecret = '';
			$response = $client->post(
			TOKEN_URL, [
				'auth' => [
					$clientId, $clientSecret
				],
				'json' => [
					'grant_type' => 'refresh_token',
					'refresh_token' => $refresh_token
				]
			]
			);
			$body = $response->getBody();
			$newCreds = json_decode($body, true);
			
			$data = array(
				'email' => $email,
				'name' => $name
				//'update_existing' => true
			);
			
			$body = $client->post($subsUrl, [
					'json' => $data, 
					'headers' => ['Authorization' => 'Bearer ' . $newCreds["access_token"]]
				]);

			// get the subscriber entry using the Location header from the post request
			$subscriberUrl = $body->getHeader('Location')[0];
			$subscriberResponse = $client->get($subscriberUrl,
				['headers' => ['Authorization' => 'Bearer ' . $newCreds["access_token"]]])->getBody();
			$subscriber = json_decode($subscriberResponse, true);
			echo json_encode(array('success'=>1 , 'message'=>'Thank you for subscribing.'));
			exit;
		}catch(Exception $e){
			echo json_encode(array('error'=>41, 'message'=>'Error subscribing on Aweber. '. $e->getMessage()));
			exit;
		}
	
 
	}
		
	//icontact
	if ($subscribe->mailerType == 5){
		
		try{
			$APPID=$subscribe->param1;
			$AppUsername=$subscribe->param2;
			$AppPassword=$subscribe->param4;
			$ListId=$subscribe->param5;
			$name=$subscribe->name;
			$email=$subscribe->email;
			$add_contact=icontact_addcontact($APPID,$AppUsername,$AppPassword,$ListId,$name,$email);
			echo json_encode(array('success'=>1));
			exit;
		}catch(Exception $e){
			echo json_encode(array('error'=>41, 'message'=>'Error subscribing on icontact. '. $e->getMessage()));
			exit;
		}
		

	}
		
	//Goto Webinar
	if ($subscribe->mailerType == 6){
		
		$firstName=$subscribe->name;
		$lastName='Friend';

		$firstName=($firstName !='')? $firstName: 'Friend';
		
		$data = array('firstName'=>$firstName, 'lastName'=>$lastName, 'email'=>$subscribe->email );
		
		$organizerkey = $subscribe->param1;
		$accessToken = $subscribe->param2;
		$webinarkey = $subscribe->param3;
		$refreshToken = $subscribe->param4;
		
		// print_r($data);
		// exit;

		$gotoWebinar = new GotoWebinar();
		$register = $gotoWebinar->SubmitGotoWebinar($data, $organizerkey, $webinarkey, $refreshToken);
		//$test = json_decode($register);
		// print_r($register);
		//exit;
		
		if ($register === false){
			echo json_encode(array('error'=>41, 'message'=>'Error subscribing on GoToWebinar.'));
			exit;
		}else{
			$pos = strpos($register, '{"joinUrl"');
			$pos1 = strpos($register, '{"registrantKey"');
			if ($pos === false && $pos1 === false) {
				echo json_encode(array('error'=>42, 'message'=>'Error subscribing on GoToWebinar.'));
				exit;
			}else{
				if ($pos) $register = substr($register, $pos);
				if ($pos1) $register = substr($register, $pos1);
				
				$result = json_decode($register);
				//print_r($result);
				echo json_encode(array('success'=>1));
				exit; 
			}
		}
	}

	//Interspire
	if ($subscribe->mailerType == 7){
		
		try{
			$URL=$subscribe->param1;
			$xml_Username=$subscribe->param2;
			$xml_token=$subscribe->param3;
			$name=$subscribe->name;
			$email=$subscribe->email;	
			$ListId=$subscribe->param4;		
			$Field=$subscribe->param5;				
			$xml = '
			<xmlrequest>
			<username>'.$xml_Username.'</username>
			<usertoken>'.$xml_token.'</usertoken>
			<requesttype>subscribers</requesttype>
			<requestmethod>AddSubscriberToList</requestmethod>
			<details>
				<emailaddress>'.$email.'</emailaddress>
				<mailinglist>'.$ListId.'</mailinglist>
				<format>html</format>
				<confirmed>yes</confirmed>';
							if (!empty($Field)) {
								$xml .= '
				<customfields>;
					<item>
						<fieldid>'.$Field.'</fieldid>
						<value>'.$name.'</value>
					</item>
				</customfields>';
							}
							$xml .= '
			</details>
		</xmlrequest>';
			$curl = curl_init($URL);
			curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($curl, CURLOPT_FORBID_REUSE, 1);
			curl_setopt($curl, CURLOPT_FRESH_CONNECT, 1);
			curl_setopt($curl, CURLOPT_HEADER, 0);
			curl_setopt($curl, CURLOPT_POST, 1);
			curl_setopt($curl, CURLOPT_POSTFIELDS, $xml);
			$response = curl_exec($curl);
			curl_close($curl);
			echo json_encode(array('success'=>1));
			exit;
		}
		catch(Exception $e){
			echo json_encode(array('error'=>41, 'message'=>'Error subscribing on interspire. '. $e->getMessage()));
			exit;
			
		}
	}
	
	
	
	//mailer SendReach
	if ($subscribe->mailerType == 8){
		//key = ;
		//secret = ;
		//list = ;
		//userid = ;
		
		try{
					
			$api_vars = array();
			$api_vars['key'] = $subscribe->param1;
			$api_vars['secret'] = $subscribe->param2;
			$api_vars['userid'] = '6161'; // this is the userid that created the API application.
			
			//print_r($api_vars);
			//exit;
			//print($subscribe->email);
			//exit;
			$sendReach = new SendReach();
			$sendReach->api_vars = $api_vars;
			
			$list_id = $subscribe->param3; // list to subscriber new user too
			$first_name = $subscribe->name; // optional but highly suggested
			$last_name = ''; // option, but highly suggested
			$email = $subscribe->email; // required
			$client_ip = getRealIp(); // required
			
			$subscriber_add = $sendReach->subscriber_add($list_id,$first_name,$last_name,$email,$client_ip); // the data is returned in json format
			$subscriber_add = json_decode($subscriber_add); // here we convert the json data into a PHP array
			
			//print_r($subscriber_add);
			//exit;
			
			if ($subscriber_add->status == 'success'){
				echo json_encode(array('success'=>1));
			}else{
				$message = '';
				if (isset($subscriber_add->error))
					$message = $subscriber_add->error;
				elseif (isset($subscriber_add->message))
					$message = $subscriber_add->message;
				
				echo json_encode(array('error'=>40, 'message'=>'Error subscribing on SendReach. '. $message));
			}
			exit;
			
		}
		catch (Exception $e){
			echo json_encode(array('error'=>41, 'message'=>'Error subscribing on SendReach. '. $e->getMessage()));
			exit;
		}
	}

	echo json_encode(array('error'=>2, 'message'=>'Invalid Mailer Type.'));
}

function getRealIp()
{
	if (!empty($_SERVER['HTTP_CLIENT_IP']))   //check ip from share internet
	{
		$ip=$_SERVER['HTTP_CLIENT_IP'];
	}
	elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR']))   //to check ip is pass from proxy
	{
		$ip=$_SERVER['HTTP_X_FORWARDED_FOR'];
	}
	else
	{
		$ip=$_SERVER['REMOTE_ADDR'];
	}
	return $ip;
}

function shai_mailchimp_subscriber_status( $email, $status, $list_id, $api_key, $firstname ){
	$merge_fields = array('FNAME' => $firstname ,'LNAME' => '');
	$data = array(
		'apikey'        => $api_key,
    	'email_address' => $email,
		'status'        => $status,
		'merge_fields'  => $merge_fields
	);
	$mch_api = curl_init(); // initialize cURL connection
 
	curl_setopt($mch_api, CURLOPT_URL, 'https://' . substr($api_key,strpos($api_key,'-')+1) . '.api.mailchimp.com/3.0/lists/' . $list_id . '/members/' . md5(strtolower($data['email_address'])));
	curl_setopt($mch_api, CURLOPT_HTTPHEADER, array('Content-Type: application/json', 'Authorization: Basic '.base64_encode( 'user:'.$api_key )));
	curl_setopt($mch_api, CURLOPT_USERAGENT, 'PHP-MCAPI/2.0');
	curl_setopt($mch_api, CURLOPT_RETURNTRANSFER, true); // return the API response
	curl_setopt($mch_api, CURLOPT_CUSTOMREQUEST, 'PUT'); // method PUT
	curl_setopt($mch_api, CURLOPT_TIMEOUT, 10);
	curl_setopt($mch_api, CURLOPT_POST, true);
	curl_setopt($mch_api, CURLOPT_SSL_VERIFYPEER, false);
	curl_setopt($mch_api, CURLOPT_POSTFIELDS, json_encode($data) ); // send data in json
 
	$result = curl_exec($mch_api);
	return $result;
}

function clean($string) {

   $string = str_replace(' ', '-', $string); // Replaces all spaces with hyphens.

   return preg_replace('/[^A-Za-z0-9\-]/', '', $string); // Removes special chars.
}	
?>