<?php

// Use this namespace
use Steampixel\Route;


if(!is_file(".htaccess"))
{


$fp = fopen (".htaccess", "w");
fwrite($fp, "DirectoryIndex index.php

# enable apache rewrite engine
RewriteEngine on

# set your rewrite base
# Edit this in your init method too if you script lives in a subfolder
RewriteBase /

# Deliver the folder or file directly if it exists on the server
RewriteCond %{REQUEST_FILENAME} !-f
RewriteCond %{REQUEST_FILENAME} !-d
 
# Push every request to index.php
RewriteRule ^(.*)$ index.php [QSA]");

fclose($fp);
}
// Include router class
include('Route.php');

// Include the Home page
Route::add('/',function($page=''){
   require __DIR__ . '/webpage.php';
});

// Include the Home page
Route::add('/Home',function($page='Home'){
   require __DIR__ . '/webpage.php';
});

// Include the about page
Route::add('/services',function($page='services'){
   require __DIR__ . '/webpage.php';
});

// Include the Team page
Route::add('/team',function($page='team'){
   require __DIR__ . '/webpage.php';
});


// Include the Contact page
Route::add('/contact',function($page='contact'){
   require __DIR__ . '/webpage.php';
});


// policy

Route::add('/policy',function($privacy=1){
   require __DIR__ . '/webpage.php';
});

// terms of service
Route::add('/terms-of-services',function($termsofservice=1){
   require __DIR__ . '/webpage.php/terms';
});


// terms of article
Route::add('/article',function(){
   require __DIR__ . '/webpage.php/article';
});

// terms of innerarticle
Route::add('/article/([A-Za-z0-9]*)',function($inner_id){
   require __DIR__ . '/webpage.php';
});

Route::pathNotFound(function($path) {
  echo 'Error 404 :-(<br>';
  echo 'The requested path "'.$path.'" was not found!';
});

Route::run('/');

?>