<?php

// Use this namespace
use Steampixel\Route;


if(!is_file(".htaccess"))
{


$fp = fopen (".htaccess", "w");
fwrite($fp, "DirectoryIndex index.php

# enable apache rewrite engine
RewriteEngine on

# set your rewrite base
# Edit this in your init method too if you script lives in a subfolder
RewriteBase /

# Deliver the folder or file directly if it exists on the server
RewriteCond %{REQUEST_FILENAME} !-f
RewriteCond %{REQUEST_FILENAME} !-d
 
# Push every request to index.php
RewriteRule ^(.*)$ index.php [QSA]");

fclose($fp);
}
// Include router class
include('Route.php');

// Include the Home page
Route::add('/',function(){
   require __DIR__ . '/home.php';
});

// Include the about page
Route::add('/about',function(){
   require __DIR__ . '/about.php';
});

// Include the Contact page
Route::add('/contact',function(){
   require __DIR__ . '/contact.php';
});


// policy

Route::add('/privacy-policy',function($privacy=1){
   require __DIR__ . '/contact.php';
});

// terms of service

Route::add('/terms-of-services',function($termsofservice=1){
   require __DIR__ . '/contact.php';
});


// Include the Story page
Route::add('/story',function(){
   require __DIR__ . '/story.php';
});


// Accept only numbers as parameter. Other characters will result in a 404 error
Route::add('/story/([0-9]*)',function($story_page){
  require __DIR__ . '/story.php';
});


// Story InnerPage
Route::add('/innerpage/([A-Za-z0-9]*)',function($inner_id){
  require __DIR__ . '/story.php';
});

// Story Wordpress page
Route::add('/wp/([A-Za-z0-9]*)',function($wp_id){
  require __DIR__ . '/story.php';
});


// topic wise like latest,hot,etc
Route::add('/topics/([A-Za-z0-9]*)',function($topic_name){
  require __DIR__ . '/story.php';
});

Route::add('/category/([A-Za-z0-9]*)',function($category_name){
  require __DIR__ . '/story.php';
});


Route::add('/type/([A-Za-z0-9]*)',function($story_type){
  require __DIR__ . '/story.php';
});


Route::add('/search',function(){
   require __DIR__ . '/story.php';
});

// Route::add('/innerpage/([A-Za-z]*)',function($var1){
//   require __DIR__ . '/story.php';
// });




Route::pathNotFound(function($path) {
  echo 'Error 404 :-(<br>';
  echo 'The requested path "'.$path.'" was not found!';
});

Route::run('/');

?>


